#include <string>
#include <unordered_map>
#define UTF16_lambda const char16_t*,const char16_t*,string_hash,string_compare
#define UTF8_lambda const char*,const char*,string_hash,string_compare

struct string_hash {
	size_t operator()(const char *txt) const {
		return std::hash<std::string_view>{}(txt);
	}
	size_t operator()(const char16_t* txt) const {
		return std::hash<std::u16string_view>{}(txt);
	}
};

struct string_compare {
	bool operator()(const char *t1, const char *t2) const {
		return strncmp(t1, t2, strlen(t2)) == 0;
	}
	bool operator()(const char16_t* t1, const char16_t* t2) const {
		return std::char_traits<char16_t>::compare(t1, t2, std::char_traits<char16_t>::length(t1)) == 0;
	}
};

namespace ENG {

	const char16_t* bootWarning = u"This is a work of fiction.\n"
	u"Any resemblance to actual people, locations,\nor organizations is purely coincidental.\n"
	u"$S020＿\n"
	u"$SPlease obey traffic laws and regulations when driving vehicles.";
	const char* save_dateformat = "%02d/%02d/%04d";
	const char16_t* medalObtained = u"Medal Obtained!";

	const char16_t* Shizuku_alt[] = {
		u"Abreast of the Moon",
		u"Mizuori-san"
	};

	const char16_t* CLEAN_TITLES[] = {
		u"Title 1!",
		u"Docile Lucifer",
		u"Lucifyela",
		u"Menswear Lucifer",
		u"Hide-acquainted Lucifer",
		u"Cursed Docile Lucifer",
		u"Lucifer of Cursed Fashion",
		u"Currsieaded Lucifyela",
		u"Cursed-Hide-acquainted Lucifer",
		u"Docile Canary 'n' Rocker",
		u"Menswear Canary 'n' Rocker",
		u"Rock 'n' Rollah",
		u"Hide-acquainted Canary 'n' Rocker",
		u"Cursed Docile Canary 'n' Rocker",
		u"Canary 'n' Rocker of Cursed Fashion",
		u"Currsieaded Rock 'n' Rollah",
		u"Cursed-Hide-acquainted Canary 'n' Rocker",
		u"Docile Champion",
		u"Menswear Champion",
		u"Champyon",
		u"Hide-acquainted Champion",
		u"Rusty Docile Champion",
		u"Boxer of Cursed Fashion",
		u"Currsieaded Champyon",
		u"Cursed-Hide-acquainted Champion",
		u"Docile Shockin' Taka",
		u"Menswear King",
		u"Shockin' Takwa",
		u"Hide-acquainted Shockin' Taka",
		u"Cursed Docile Shockin' Taka",
		u"Cursed King Taka of Fashion",
		u"Currsieaded Shockin' Takwa",
		u"Cursed Hide-admirer Taka",
		u"Delinquent Queen II",
		u"Delinquent-Queen-Cursed-Hide-Acquainted Lucifer",
		u"Crayfish Master",
		u"King Stag Beetle",
		u"Unmai-bou Collector'",
		u"Sour-perstar",
		u"Dark Master: 5 Yen",
		u"Breathless Bourgeois",
		u"Balance-focused GM",
		u"World-class GM",
		u"Lucifer of Popularity",
		u"Canary of Popularity",
		u"Champion of Popularity",
		u"Shockin' Taka of Popularity",
		u"Granny Killer",
		u"Shota Hunter", //Shimamon Fight
		u"Loli King", //Shimamon Fight
		u"Loli Hunter", //Shimamon Fight
		u"Loli Emperor", //Shimamon Fight
		u"Shimamon Fight King",
		u"Golden Dragon", //Shimamon Fight
		u"Legendary King of Ping-Pong",
		u"Ping-Pong God",
		u"Ping-Pong"
	};

	const char16_t* TITLES[] = {
		u"You got a Title 1!",
		u"Obtained the title \"Docile Lucifer\"!",
		u"Obtained the title \"Lucifyela\"!",
		u"Obtained the title \"Menswear Lucifer\"!",
		u"Obtained the title \"Hide-acquainted Lucifer\"!",
		u"Obtained the title \"Cursed Docile Lucifer\"!",
		u"Obtained the title \"Lucifer of Cursed Fashion\"!",
		u"Obtained the title \"Currsieaded Lucifyela\"!",
		u"Obtained the title \"Cursed-Hide-acquainted Lucifer\"!",
		u"Obtained the title \"Docile Canary 'n' Rocker\"!",
		u"Obtained the title \"Menswear Canary 'n' Rocker\"!",
		u"Obtained the title \"Rock 'n' Rollah\"!",
		u"Obtained the title \"Hide-acquainted Canary 'n' Rocker\"!",
		u"Obtained the title \"Cursed Docile Canary 'n' Rocker\"!",
		u"Obtained the title \"Canary 'n' Rocker of Cursed Fashion\"!",
		u"Obtained the title \"Currsieaded Rock 'n' Rollah\"!",
		u"Obtained the title \"Cursed-Hide-acquainted Canary 'n' Rocker\"!",
		u"Obtained the title \"Docile Champion\"!",
		u"Obtained the title \"Menswear Champion\"!",
		u"Obtained the title \"Champyon\"!",
		u"Obtained the title \"Hide-acquainted Champion\"!",
		u"Obtained the title \"Rusty Docile Champion\"!",
		u"Obtained the title \"Boxer of Cursed Fashion\"!",
		u"Obtained the title \"Currsieaded Champyon\"!",
		u"Obtained the title \"Cursed-Hide-acquainted Champion\"!",
		u"Obtained the title \"Docile Shockin' Taka\"!",
		u"Obtained the title \"Menswear King\"!",
		u"Obtained the title \"Shockin' Takwa\"!",
		u"Obtained the title \"Hide-acquainted Shockin' Taka\"!",
		u"Obtained the title \"Cursed Docile Shockin' Taka\"!",
		u"Obtained the title \"Cursed King Taka of Fashion\"!",
		u"Obtained the title \"Currsieaded Shockin' Takwa\"!",
		u"Obtained the title \"Cursed Hide-admirer Taka\"!",
		u"Obtained the title \"Delinquent Queen II\"!",
		u"$S030Obtained the title \"Delinquent-Queen-Cursed-Hide-Acquainted Lucifer\"!$S",
		u"Obtained the title \"Crayfish Master\"!",
		u"Obtained the title \"King Stag Beetle\"!",
		u"Obtained the title \"Unmai-bou Collector'",
		u"Obtained the title \"Sour-perstar\"!",
		u"Obtained the title \"Dark Master: 5 Yen\"!",
		u"Obtained the title \"Breathless Bourgeois\"!",
		u"Obtained the title \"Balance-focused GM\"!",
		u"Obtained the title \"World-class GM\"!",
		u"Obtained the title \"Lucifer of Popularity\"",
		u"Obtained the title \"Canary of Popularity\"!",
		u"Obtained the title \"Champion of Popularity\"!",
		u"Obtained the title \"Shockin' Taka of Popularity\"!",
		u"Obtained the title \"Granny Killer\"!",
		u"Obtained the title \"Shota Hunter\"!", //Shimamon Fight
		u"Obtained the title \"Loli King\"!", //Shimamon Fight
		u"Obtained the title \"Loli Hunter\"!", //Shimamon Fight
		u"Obtained the title \"Loli Emperor\"!", //Shimamon Fight
		u"Obtained the title \"Shimamon Fight King\"!",
		u"Obtained the title \"Golden Dragon\"!", //Shimamon Fight
		u"Obtained the title \"Legendary King of Ping-Pong\"!",
		u"Obtained the title \"Ping-Pong God\"!",
		u"Obtained the title \"Ping-Pong\"!"
	};

	const char16_t* MEDALS[] = {
		u"Lucifer",
		u"Canary 'n' Rocker",
		u"Champion",
		u"Shockin Taka",
		u"Docile Lucifer",
		u"Menswear Lucifer",
		u"Lucifyela",
		u"Hide-acquainted Lucifer",
		u"Cursed Docile Lucifer",
		u"Lucifer of Cursed Fashion",
		u"Currsieaded Lucifyela",
		u"Cursed-Hide-acquainted Lucifer",
		u"Docile Canary 'n' Rocker",
		u"Menswear Canary 'n' Rocker",
		u"Rock 'n' Rollah",
		u"Cursed-Hide-acquainted Canary 'n' Rocker",
		u"Cursed Docile Canary 'n' Rocker",
		u"Canary 'n' Rocker of Cursed Fashion",
		u"Currsieaded Rock 'n' Rollah",
		u"Cursed-Hide-acquainted Canary 'n' Rocker",
		u"Docile Champion",
		u"Menswear Champion",
		u"Champyon",
		u"Hide-acquainted Champion",
		u"Rusty Docile Champion",
		u"Boxer of Cursed Fashion",
		u"Currsieaded Champyon",
		u"Cursed-Hide-acquainted Champion",
		u"Docile Shockin' Taka",
		u"Menswear King",
		u"Shockin' Takwa",
		u"Hide-acquainted Shockin' Taka",
		u"Cursed Docile Shockin' Taka",
		u"Cursed King Taka of Fashion",
		u"Currsieaded Shockin' Takwa",
		u"Cursed Hide-admirer Taka",
		u"Delinquent-Queen-Cursed-Hide-Acquainted Lucifer",
		u"Delinquent Queen II",
		u"Got a uniform that wouldn't suit Kyouko",
		u"Obtained a carving of a fish",
		u"Obtained a doll with a hollow expression",
		u"Took a bath with Umi",
		u"Peeked at Umi and Kyouko in the bath",
		u"King Stag Beetle",
		u"Made Torishirojima paella",
		u"Made vegetable stir-fried rice",
		u"Made spicy mountain mushroom rice",
		u"Made some foil-grilled fish",
		u"Made a countryside scavenger bowl",
		u"Made \"Blessings of the mountains and seas\"",
		u"Made a Torishiro scavenger stir-fry",
		u"Made wild veggie rice",
		u"Made rice with minced sea bream",
		u"Made mushroom potage",
		u"Earned 50,000 yen from Shiroha's original recipe",
		u"Taught the kids the word 'whimpering'",
		u"Made a monetary offering to Ao",
		u"Learned Ao's maidenly secret",
		u"Heard Inari say Pon-kyu-pon",
		u"Gazed into the pinkness of the blue sky",
		u"Trained Ao with treats",
		u"Stole Ao's maidenly innocence",
		u"Enjoyed Inari's belly to the fullest",
		u"Unmai-bou Collector",
		u"Sour-perstar",
		u"Dark Master: 5 Yen",
		u"Breathless Bourgeois",
		u"Balance-focused GM",
		u"World-class GM",
		u"Got named Takamagahara Hairi",
		u"Got named TakaHarassment",
		u"Got named Good Morning",
		u"Faced the boobs with Shizuku",
		u"Got called good lookin’",
		u"Enjoyed shaved ice using colored glasses",
		u"Painted Ryouichi's body",
		u"Lucifer of Popularity",
		u"Canary of Popularity",
		u"Champion of Popularity",
		u"Shockin Taka of Popularity",
		u"Granny Killer",
		u"Made an offering at the shrine for the first time",
		u"Performed a shrine visit correctly",
		u"Presented Inari as an offering at the shrine",
		u"Offered 1,000 yen at the shrine",
		u"Visited the shrine to the point of enlightenment",
		u"Drew a fortune",
		u"Took on an angelic alias with Umi",
		u"Made Umi call you Onii-chan",
		u"Made Umi call you Papa",
		u"Got called a lolicon by Umi in English",
		u"Made Umi call you Master",
		u"Made Umi call you a stupid pig",
		u"Became feared as an invulnerable lolicon",
		u"Cleared Shiroha's route",
		u"Cleared Ao's route",
		u"Cleared Kamome's route",
		u"Cleared Tsumugi's route",
		u"Cleared Alka Tale",
		u"Completed Summer Pockets",
		u"Became a Shimamon Fighter",
		u"Obtained your first Shimamon",
		u"Obtained your first 2★ Shimamon",
		u"Obtained your first 3★ Shimamon",
		u"Obtained your first 4★ Shimamon",
		u"Obtained your first 5★ Shimamon",
		u"Obtained your first ultra-rare Shimamon",
		u"Own 5 different Shimamon at once",
		u"Own 10 different Shimamon at once",
		u"Own 20 different Shimamon at once",
		u"Obtained Inari in Shimamon Fight",
		u"Obtained Ryouichi in Shimamon Fight",
		u"Obtained Ryouichi using Umi's panties in Shimamon Fight",
		u"Obtained Tenzen in Shimamon Fight",
		u"Obtained Tenzen using an earthworm in Shimamon Fight",
		u"Obtained Tenzen using Umi's panties in Shimamon Fight",
		u"Obtained Genbu in Shimamon Fight",
		u"Obtained Genbu using Umi's panties in Shimamon Fight",
		u"Obtained Byakko in Shimamon Fight",
		u"Obtained Seiryuu in Shimamon Fight",
		u"Obtained Suzaku in Shimamon Fight",
		u"Collected all four Heavenly Beasts in Shimamon Fight",
		u"Registered 10 different Shimamon in your Shimadex",
		u"Registered 30 different Shimamon in your Shimadex",
		u"Registered 50 different Shimamon in your Shimadex",
		u"Registered 75 different Shimamon in your Shimadex",
		u"Registered All 100 different Shimamon in your Shimadex",
		u"Obtained 5 different kinds of Shimamon bait",
		u"Obtained 10 different kinds of Shimamon bait",
		u"Obtained All 20 different kinds of Shimamon bait",
		u"Discovered 5 different Shimamon bait locations",
		u"Discovered All 10 different Shimamon bait locations",
		u"Won your first Shimamon Fight",
		u"Defeated Naruse Shiroha in Shimamon Fight",
		u"Defeated Sorakado Ao in Shimamon Fight",
		u"Defeated Kushima Kamome in Shimamon Fight",
		u"Defeated Tsumugi Wenders in Shimamon Fight",
		u"Defeated Umi in Shimamon Fight",
		u"Defeated powered-up Umi in Shimamon Fight",
		u"Defeated Misaki Kyouko in Shimamon Fight",
		u"Defeated Mitani Ryouichi in Shimamon Fight",
		u"Defeated Kanou Tenzen in Shimamon Fight",
		u"Defeated Nomura Miki in Shimamon Fight",
		u"Defeated Mizuori Shizuku in Shimamon Fight",
		u"Defeated Genbu (fake) in Shimamon Fight",
		u"Defeated Genbu in Shimamon Fight",
		u"Defeated Sorakado Ai in Shimamon Fight",
		u"Rose above rank 31 in Shimamon Fight",
		u"Rose above rank 21 in Shimamon Fight",
		u"Rose above rank 11 in Shimamon Fight",
		u"Achieved rank 1 in Shimamon Fight",
		u"Shota Hunter",
		u"Loli King",
		u"Loli Hunter",
		u"Loli Emperor",
		u"Golden Dragon",
		u"Shimamon Fight King",
		u"Learned about the wild Tenzen while Fighting Ao",
		u"Lost a round to Nomiki after she cheated",
		u"Saw the truth of humanoid Shimamon",
		u"Witnessed a double-Ryouichi howling purge",
		u"Saw Tenzen damage himself",
		u"Teased Umi in the Shimamon Fight tutorial",
		u"Angered Umi in the Shimamon Fight tutorial",
		u"Defeated Umi in the Shimamon Fight tutorial",
		u"Played ping-pong for the first time",
		u"Played ping-pong 3 times",
		u"Played ping-pong 5 times",
		u"Got sucked into the Tenzen Zone for the first time",
		u"Got sucked into the Tenzen Zone 5 times",
		u"Got sucked into the Tenzen Zone 10 times",
		u"Achieved a max combo of 10 in ping-pong",
		u"Achieved a max combo of 30 in ping-pong",
		u"Achieved a max combo of 50 in ping-pong",
		u"Made Tenzen return 100 shots",
		u"Made Tenzen return 200 shots",
		u"Made Tenzen return 300 shots",
		u"Achieved a score of 5 million in ping-pong",
		u"Achieved a score of 30 million in ping-pong",
		u"Returned every ball in Directed Mode",
		u"Achieved a score of 3,000 in Directed Mode",
		u"Lasted 3 min in Endless Mode",
		u"Lasted 5 min in Endless Mode",
		u"Achieved a score of 50,000 in Endless Mode",
		u"Achieved a score of 100,000 in Endless Mode",
		u"Played a serious ping-pong match against Tenzen",
		u"Used your first hidden technique in ping-pong",
		u"Used a hidden technique 20 times in ping-pong",
		u"Blew Tenzen off court in ping-pong",
		u"Blew Tenzen off court 10 times in ping-pong",
		u"Knocked Tenzen out in ping-pong for the first time",
		u"Dealt a total of 999,999 damage to Tenzen in ping-pong",
		u"Achieved a score of 50,000 in Extreme Mode",
		u"Achieved a score of 20 million in Extreme Mode",
		u"Learned \"Transcendence: The Everlasting Moment\"",
		u"Used \"Transcendence: The Everlasting Moment\"",
		u"Learned \"Ultimate Technique: Roar of the Tanuki\"",
		u"Used \"Ultimate Technique: Roar of the Tanuki\"",
		u"Cursed Tenzen in ping-pong",
		u"Played around with Tenzen's pure heart",
		u"Earned 5,000 yen from Shiroha's original recipe",
		u"Earned 20,000 yen from Shiroha's original recipe",
		u"Tried to lead an island tour; got lost",
		u"Complimented Ao's hair tie",
		u"Wondered about Kamome's suitcase",
		u"Played with Ryouichi's precious memories",
		u"Experienced the carp of another",
		u"Experienced the hark of another",
		u"Experienced the narc of another",
		u"Experienced the \"heart\" of another",
		u"Granted your 500% Lucky Powder dream",
		u"Purged in front of Nomiki; got shot",
		u"Leered at Nomiki's shorts",
		u"Said it's for boobs",
		u"Hugged by Shizuku",
		u"Said you love boobs",
		u"Had the sushi set to go",
		u"Had katsudon to go",
		u"Had the cream bun set to go",
		u"Had a happy meal to go",
		u"Had Shiroha cancel your Kamehameha",
		u"Cleared Miki's route",
		u"Cleared Shizuku's route",
		u"Cleared Umi's route",
		u"Cleared Shiki's route",
		u"Defeated Kamiyama Shiki in Shimamon Fight",
		u"Became a Shimapong Player",
		u"Won your first Shimapong singles match",
		u"Beat five Players in Shimapong singles matches",
		u"Beat all Players in Shimapong singles matches",
		u"Won your first Shimapong doubles match",
		u"Won the Shimapong Fight Doubles Tournament",
		u"Beat the Tenzen/Inari team",
		u"Beat Boss-Tenzen in Shimapong Fight",
		u"Played a Shimapong Fight free match",
		u"Hit 100 rally shots total in Shimapong Fight",
		u"Hit 500 rally shots total in Shimapong Fight",
		u"Unleashed your first special move in Shimapong Fight",
		u"Unleashed 30 special moves in Shimapong Fight",
		u"Unleashed your first super-special move in Shimapong Fight",
		u"Sent your opponent's racket flying in Shimapong Fight",
		u"Hit 10 smashes in Shimapong Fight",
		u"Hit your first counter-smash in Shimapong Fight",
		u"Won your first zone battle in Shimapong Fight",
		u"Received a racket replacement in Shimapong Fight",
		u"Won a Shimapong Fight match in critical condition",
		u"Toyed with Tenzen's heart with Shizuku in Shimapong Fight",
		u"Saw Nomiki cancel Ryouichi's zone in Shimapong Fight",
		u"Received a racket from Tenzen in Shimapong Fight",
		u"Spread the candy store's curse throughout Shimapong Fight",
		u"Defeated Abreast of the Moon in Shimamon Fight" //index 142 Alt
	};

	namespace SHIMAMON {

		const char* Deck_name_prompt = "Please enter a deck name.";

		const char16_t* Deck_default_names[] = {
			u"Deck1",
			u"Deck2",
			u"Deck3"
		};

		struct ShimamonText {
			const char16_t* Name;
			const char16_t* Description;
		};

		//Description is automatically breaked by game
		constexpr std::array ITEMS = {
			ShimamonText{u"Sugar Water",
				u"Sugar mixed with tap water. Nothing more, nothing less."},
			ShimamonText{u"Melon Rind",
				u"All that's left after you eat the good part."},
			ShimamonText{u"Earthworm",
				u"Found by digging in just the right place. Or, well, anywhere."},
			ShimamonText{u"Popsicle Stick",
				u"Unfortunately, it's not a winner. The question is, who ate it?"},
			ShimamonText{u"Insect Jelly",
				u"Used to raise insects. Surprisingly firm."},
			ShimamonText{u"Shaved Ice Syrup",
				u"A wicked substance that creates the illusion of flavor\nby color alone."},
			ShimamonText{u"Eggplant",
				u"A delicious eggplant. Has no hidden meaning whatsoever."},
			ShimamonText{u"Spoon Worm",
				u"It looks gross, but it's a delicacy. Fish love them."},
			ShimamonText{u"Bonito Flakes",
				u"An incredible source of umami and one of Japan's most prized ingredients. Smells great, too."},
			ShimamonText{u"Torishiro Honey",
				u"Has a full-bodied fragrance and a mild flavor."},
			ShimamonText{u"Lewd Magazine",
				u"Could make any middle schooler's heart race."},
			ShimamonText{u"Failed Fried Rice",
				u"The desiccated shadow of what might have once been fried rice."},
			ShimamonText{u"Sea Wookie",
				u"Their eggs hatch when exposed to water. Rumor has it they're actually an alien life-form."},
			ShimamonText{u"Rice Syrup",
				u"A sugary syrup. Its mild flavor can be attributed to the secret technique it's made with."},
			ShimamonText{u"Fish Sausage",
				u"Beloved by all, young and old. Go ahead, take a bite―it's perfectly tasty on its own."},
			ShimamonText{u"Lewd Magazine R",
				u"Could make any adult's heart race."},
			ShimamonText{u"Ultimate Fried Rice",
				u"Perfectly-cooked fried rice. It shines with a golden luster."},
			ShimamonText{u"Lewd Magazine EX",
				u"It really doesn't get any lewder than this."},
			ShimamonText{u"Legendary Shochu",
				u"An irresistible treat for booze aficionados. Not very easy to find."},
			ShimamonText{u"Umi's Panties",
				u"100% cotton. Hard to look at directly, for several reasons."}
		};

		//Matches perfectly order from OTHCG/SFIGHT_FEED_SETTING_SPOT_IMAGE
		constexpr std::array BAIT_LOCATIONS = {
			ShimamonText{u"Mountains",
				u"If you feel like hiking."},
			ShimamonText{u"Beach",
				u"The perfect place to swim in the sea."},
			ShimamonText{u"Lake",
				u"A good place for a quiet walk."},
			ShimamonText{u"Mountain Depths",
				u"A far off area with lots of Shimamon."},
			ShimamonText{u"Coast",
				u"Shimamon bustle about at the sandy shore."},
			ShimamonText{u"Shrine",
				u"A sacred place. Full of occult-appreciating Shimamon."},
			ShimamonText{u"Mountain's Heart",
				u"A tranquil place, hidden deep in the mountains."},
			ShimamonText{u"Cliff",
				u"Few people visit this wild area."},
			ShimamonText{u"Pirate Cave",
				u"A place shrouded in mystery."},
			ShimamonText{u"Forgotten Land",
				u"This place has been long forgotten by the public."}
		};

		const char16_t* ATTRIBUTES[] = {
			u"Sky",
			u"Sea",
			u"Land"
		};

		//Descriptions are not automatically breaked for whatever reason. Da fuq, Japan?
		constexpr std::array SHIMAMONS = {
			ShimamonText(u"Migratory Locust", 
				u"A locust that flies where\nthe winds take it.\nNot to be confused with\nthe Longheaded Locust."),
			ShimamonText{u"Longheaded Locust", 
				u"Surprisingly, these two\nare not parent and child.\nThe top one's just\na freeloader."},
			ShimamonText{u"Bush Cricket", 
				u"Plays a jaunty tune for the\nants as they work.\nWho needs food, anyway?"},
			ShimamonText{u"Garden Cricket", 
				u"Its name looks really cool\nwhen written in kanji,\nbut that'd sort of defeat\nthe purpose of the translation,\nwouldn't it?"},
			ShimamonText{u"Mole Cricket", 
				u"This cricket looks like a friend.\nIts forelegs are crazy buff."},
			ShimamonText{u"Little Mantis", 
				u"A frail-looking mantis.\nSurprisingly scary when it\nspreads its wings."},
			ShimamonText{u"Drone Beetle", 
				u"A beetle with a strikingly\nbeautiful jade shell,\nvisible even from a distance.\nWhich is good, since it'll never\nlet you get close to it."},
			ShimamonText{u"Stink Bug", 
				u"An aptly-named beetle that\nlives in the mountains.\nSome claim they smell exactly\nlike cilantro."},
			ShimamonText{u"Pillbug", 
				u"A round little bug that children\nlove. If you don't feel an urge\nto poke it, you know\nyour childhood's over."},
			ShimamonText{u"Carpenter Ant", 
				u"If it has wings, you know it's\nstilla juvenile. Try not\nto be too rough with it."},
			ShimamonText{u"Lizard", 
				u"Can sever its own tail to serve\nas a decoy, rendering\nan enemy attack ineffective.\nWon't actually bother in\na Shimamon fight, though."},
			ShimamonText{u"Gecko", 
				u"Often found clinging to walls\nand ceilings. Resembles newts,\nbut since those are aquatic,\nthey're technically a different\nspecies."},
			ShimamonText{u"Jumping Spider", 
				u"Looks horrifying, but hunts\npests and is actually a really\nnice arachnid to have in\nthe house. Go get 'em,\nJumping Spider!"},
			ShimamonText{u"Fiddler Crab", 
				u"An autonomous defense-bot\ndesigned specifically for\nanti-personnel combat... not."},
			ShimamonText{u"Barnacle", 
				u"It certainly looks unappetizing,\nbut it's actually really tasty\nwhen boiled and makes superb\nsoup stock."},
			ShimamonText{u"Octopus", 
				u"Its ink is supposedly quite\ntasty."},
			ShimamonText{u"Sand Lance", 
				u"The absolute bottom of the\nfood chain, both on\nland and at sea.\nSometimes called a Lancefish.\nNot very useful in a joust."},
			ShimamonText{u"Starfish", 
				u"Supposedly gives excellent\nhugs."},
			ShimamonText{u"Sea Hare", 
				u"An entirely hermaphroditic\nspecies. No joke here,\nthey're just sorta neat."},
			ShimamonText{u"Hermit Crab", 
				u"A true hermit makes their\nhome wherever they are...\nor just brings it with them.\nTiny and adorable."},
			ShimamonText{u"Aurelia", 
				u"Looks wondrously beautiful\nfloating in the water.\nVenomous, but not, like,\nTHAT venomous."},
			ShimamonText{u"Manila Clam", 
				u"Sprinkle with sake and put on\na grill. Let steam until\nits shell opens, then\nseason with a pinch\nof salt and enjoy!"},
			ShimamonText{u"Crayfish", 
				u"An American breed of crayfish.\nOnly sings anime songs when\nyou take it to karaoke,\nfor some reason."},
			ShimamonText{u"Pond Slider", 
			u"A type of turtle that can be\nfound in many ponds. Also\nan invasive species. Whatever\nyou do, don't let it back into\nthe wild."},
			ShimamonText{u"Tree Frog", 
				u"Ribbit, ribbit! Hop, ribbit,\nhippity hop!"},
			ShimamonText{u"Newt", 
				u"A helpful little lizard that\ngobbles up pests in rice fields."},
			ShimamonText{u"Cabbage Butterfly", 
				u"Known as a 'cabbage butterfly'\nin English. ...What?"},
			ShimamonText{u"Swallowtail", 
				u"Is not a swallow, does not\nhave a tail and does not\nlook like a swallow's tail.\nFunny, that."},
			ShimamonText{u"Chinese Peacock", 
				u"Resembles a black swallowtail,\nbut is distinguished by the\nunique pattern on its wings."},
			ShimamonText{u"Yamato Shijimi", 
				u"Shares its name with a species\nof shellfish. This is\none of the flying ones."},
			ShimamonText{u"Red Ring Skirt", 
				u"An invasive species that's very\ncommon around mainland Asia.\nNotoriously territorial."},
			ShimamonText{u"Honeybee", 
				u"A poor, pathetic orphan that's\nlost its queen. Has set\nout on an epic journey\nto find a hive to call home."},
			ShimamonText{u"Carpenter Bee", 
				u"Short, stubby, and way too\ncute to be scary.\nOnly the females can sting."},
			ShimamonText{u"Large Brown Cicada", 
				u"Chiiiiirp chirp chirp chirp chirp...\nChiiiiirp chirp chirp chirp chirp..."},
			ShimamonText{u"Mingming Cicada", 
				u"Miiiiiiing ming ming ming ming...\nMiiiiiiing ming ming ming ming..."},
			ShimamonText{u"Walker's Cicada", 
				u"Waaalker walker walker walker...\nWaaalker walker walker walker..."},
			ShimamonText{u"Evening Cicada", 
				u"Also known as a Higurashi\ncicada."},
			ShimamonText{u"Sparrow", 
				u"Grows a super fluffy set of\nplumage in the winter.\nA tiny little ball o'fluff."},
			ShimamonText{u"Turtle Dove", 
				u"Often mistaken for a common\npigeon. Rumored to be\na sign of good fortune."},
			ShimamonText{u"Hiyodori", 
				u"A fairly rare species of bird.\nOnly lives on certain specific\nJapanese islands."},
			ShimamonText{u"Giant Mantis", 
				u"Wields a pair of massive\nscythes that can even slice\nthrough certain small mammals."},
			ShimamonText{u"Iridescent Mantis", 
				u"A species of mantis\nsupposedly not found in Japan.\nKnown for its distinctively\ncolored shell. Not to be\nconfused with other iridescent\nbugs."},
			ShimamonText{u"Orchid Mantis", 
				u"A natural assassin that\ndisguises itself as a flower\nto lure its prey in for the kill."},
			ShimamonText{u"Miyama Stag Bug", 
				u"A common target for juvenile\nbug-catchers. Technically\na stag beetle, but that\nwouldn't fit in the text box."},
			ShimamonText{u"Sawtooth Stag Bug", 
				u"Kick enough trees and you'll\nfind one eventually.\nMighty warriors."},
			ShimamonText{u"Tanuki", 
				u"A ferocious, feral tanuki.\nVery much not a cute cartoon\nanimal. Does not say 'pon.'"},
			ShimamonText{u"Rabbit", 
				u"BUNNY!"},
			ShimamonText{u"Rat Snake", 
				u"An unremarkable snake seen\nall over Japan. Easy\nto raise and breed."},
			ShimamonText{u"Grass Lizard", 
				u"Peerlessly agile and\nquick-witted. Blink, and\nit's gone."},
			ShimamonText{u"Raccoon", 
				u"Looks cute at a glance, but\nwill rip your face off if you\ngive it the chance."},
			ShimamonText{u"Giant Isopod", 
				u"A deep-sea crustacean that's\ndelicious when deep-fried.\nJust don't think about how\nyou're basically eating a huge\npillbug."},
			ShimamonText{u"Coconut Crab", 
				u"The very definition of a giant\nenemy crab. The absolute\nlast thing you want to run\ninto in a dark alleyway."},
			ShimamonText{u"Orient Clam", 
				u"Wash carefully and simmer\nin sake, then season with\na dash of soy sauce and grill."},
			ShimamonText{u"Angelfish", 
				u"A beautifully colored tropical\nfish. A real jackass when you\nget to know it, though."},
			ShimamonText{u"Sea Angel", 
				u"A tiny sea creature. Looks like\nan angel when swimming\naround and like an eldritch\nabomination when eating."},
			ShimamonText{u"Red King Crab", 
				u"Delicious boiled, grilled,\nor eaten raw. Even its\ninnards taste amazing."},
			ShimamonText{u"Snakehead", 
				u"Don't be fooled by its name―\nits body's perfectly snake-like,\ntoo."},
			ShimamonText{u"Planarian", 
				u"One of the hardiest lifeforms\non earth, adapted to live\njust about anywhere.\nNot so great on the offensive\nfront, though."},
			ShimamonText{u"Island Eel", 
				u"An endangered species with\nthick, meaty flesh and\nmelt-in-your-mouth fat.\nImmorality's never been\nmore delicious."},
			ShimamonText{u"Blowfish", 
				u"Sometimes tiny and skinny,\nsometimes huge and puffy.\nSome species carry\ntetrodotoxin. Wearing gloves\nmight be a good idea."},
			ShimamonText{u"Dragonfly", 
				u"It looks beautiful and elegant,\nbut it's actually carnivorous.\nKnown to occasionally prey\non giant hornets."},
			ShimamonText{u"Giant Hornet", 
				u"The supreme ruler of the skies.\nIts sting is toxic enough to\neven kill humans, on occasion."},
			ShimamonText{u"Giant Cicada", 
				u"CHIIIIIRP CHIP CHIRP CHIRP...\nCHIIIIIRP CHIP CHIRP CHIRP..."},
			ShimamonText{u"Morpho Butterfly", 
				u"Famed as the most beautiful\nbutterfly in the world."},
			ShimamonText{u"Black Swallowtail", 
				u"A butterfly that tends to live\ndeep within the mountains.\nBlack never goes out of style."},
			ShimamonText{u"Shelduck", 
				u"A migratory bird with\na strikingly red beak.\nDoes not have a shell."},
			ShimamonText{u"Black-Headed Gull", 
				u"A species of seagull, known as\na 'yurikamome' in Japanese.\nThe namesake of a train line\nin Tokyo, and maybe one\nor two other things."},
			ShimamonText{u"House Martin", 
				u"Likes to nest under the eaves\nof houses. Probably a good\nidea to lay down some\ncardboard underneath sooner\nrather than later."},
			ShimamonText{u"Mallard Duck", 
				u"Males have colorful plumage\nduring their mating season,\nthen molt it all away for\nthe rest of the year. Posers."},
			ShimamonText{u"Bat", 
				u"They are the night."},
			ShimamonText{u"Jewel Caterpillar", 
				u"Its insides are totally exposed\nfor all to see. L-Lewd!"},
			ShimamonText{u"Horned Devil", 
				u"Has a pair of devilish horns,\nbut is actually totally harmless."},
			ShimamonText{u"Hercules Beetle", 
				u"The undisputed king of the\nrhinoceros beetles. It's so\nfamous, the ancient Greeks\nnamed a mythological hero\nafter it."},
			ShimamonText{u"Giraffe Stag Bug", 
				u"Can take down any prey\nwith its outrageously massive\njaw."},
			ShimamonText{u"Armadillo Lizard", 
				u"In spite of their rock-like skin,\nthese little guys are just the\nCUTEST. The perfect mix of\ncool and adorable."},
			ShimamonText{u"Giant Oarfish", 
				u"Said to be the origin\nof mermaid myths all\naround the world.\nAlso very tasty."},
			ShimamonText{u"Giant Squid", 
				u"Massive beyond all belief,\nwith tentacles to spare.\nRumored (inaccurately) to do\nuntoward things to young\nwomen when given the chance."},
			ShimamonText{u"Arapaima", 
				u"Evolved over a hundred million\nyears ago, and hasn't changed\na bit since. Truly the peak\nof evolutionary potential."},
			ShimamonText{u"Giant Clam", 
				u"The world's largest shellfish,\nweighing up to 200 kilograms.\nThe ultimate defensive\nShimamon."},
			ShimamonText{u"Nomura Jellyfish", 
				u"A true prince among jellyfish."},
			ShimamonText{u"Queen's Birdwing", 
				u"Protected by the Convention\non International Trade in\nEndangered Species of Wild\nFauna and Flora.\nIts stats have been adjusted\naccordingly."},
			ShimamonText{u"Giant Petaltail", 
				u"A living fossil of a dragonfly,\nand the largest of its kind."},
			ShimamonText{u"17 Year Cicada", 
				u"Appear en masse on\na seventeen year cycle\n in honestly unsettling\nnumbers."},
			ShimamonText{u"Bee Hummingbird", 
				u"The smallest bird in the world,\nweighing in at three grams\ntotal. So cute, other Shimamon\ncan barely bring themselves\nto hit it."},
			ShimamonText{u"White Falcon", 
				u"A falcon said to dive at the\nspeed of light. Also known\nas a shiroha falcon.\nNo relation to THAT Shiroha."},
			ShimamonText{u"Chupacabra", 
				u"A notorious, bloodsucking\ncryptid. Its ecology is\nshrouded in mystery."},
			ShimamonText{u"Inari", 
				u"A fox (probably) that can only\nbe found on Torishirojima."},
			ShimamonText{u"Japanese Wolf", 
				u"A supposedly extinct species\n of wolf. Its razor-sharp\nfangs and cunning intellect put\nit among the upper echelons\nof local predators."},
			ShimamonText{u"Frilled Shark", 
				u"A legendary shark that's\ninspired all sorts of folklore,\nnot to mention kaiju movies."},
			ShimamonText{u"Ryouichi", 
				u"Runs around half-naked all\nthe time, but actually\nhas surprisingly sensitive skin."},
			ShimamonText{u"King of the Pond", 
				u"Nobody's seen it in person,\nbut everyone knows it's there."},
			ShimamonText{u"Merman", 
				u"Its flesh is red and tuna-like,\nits limbs are crunchy,\nand its brains are creamy and\ndelicious. A delicacy known\nonly to island fishermen."},
			ShimamonText{u"Quetzalcoatl", 
				u"A feathered serpent-god said\nto have granted humanity\nits knowledge."},
			ShimamonText{u"Tenzen", 
				u"Praise his ping-pong skills,\nand he'll be like putty\nin your hands."},
			ShimamonText{u"Yatagarasu", 
				u"A three-legged crow that\nserves as a messenger of\nthe gods. Opponent skips\ntheir next draw phase."},
			ShimamonText{u"Byakko", 
				u"An old man who's claimed\nthe name of the Heavenly\nBeast of the West."},
			ShimamonText{u"Seiryuu", 
				u"An old man who's claimed\nthe name of the Heavenly\nBeast of the East."},
			ShimamonText{u"Suzaku", 
				u"An old man who's claimed\nthe name of the Heavenly\nBeast of the South."},
			ShimamonText{u"Genbu", 
				u"An old man who's claimed\nthe name of the Heavenly\nBeast of the North."},
			ShimamonText{u"Golden Dragon", 
				u"The king of the Heavenly\nBeasts."},
			ShimamonText{u"Ryouichi Mk.II", nullptr},
			ShimamonText{u"Tenzen Mk.II", nullptr},
			ShimamonText{u"NoMiki", nullptr}
		};

		struct ShimamonFightersText {
			const char16_t* Name;
			const char16_t* Description;
			const char16_t* AlterName;
			int Description_fontsize;
		};

		constexpr std::array FIGHTERS = {
			ShimamonFightersText{u"Hairi",
				nullptr, nullptr, -1},
			ShimamonFightersText{u"Shiroha",
				u"Island's only dosukoi user", nullptr, -1},
			ShimamonFightersText{u"Ao",
				u"Knightly Princess", nullptr, -1},
			ShimamonFightersText{u"Kamome",
				u"Captain Kamome", nullptr, -1},
			ShimamonFightersText{u"Tsugumi",
				u"Puppet Master", nullptr, -1},
			ShimamonFightersText{u"Umi",
				u"Treasure of the Cliffside", nullptr, -1},
			ShimamonFightersText{u"Kyouko",
				u"Poison Master", nullptr, -1},
			ShimamonFightersText{u"Ryouichi",
				u"King of Nudity", nullptr, -1},
			ShimamonFightersText{u"Tenzen",
				u"Prince of Table Tennis", nullptr, -1},
			ShimamonFightersText{u"Nomiki",
				u"Green God of Death", nullptr, -1},
			ShimamonFightersText{u"Shizuku",
				u"Untrodden Twin Peaks", nullptr, -1},
			ShimamonFightersText{u"Kobato",
				u"Steadfast King of the North Star", u"ShimaKing", 22},
			ShimamonFightersText{u"Ai",
				u"Loves Ao-chan", nullptr, -1},
			ShimamonFightersText{u"Fake Genbu",
				u"Amnesiac King of the North Star", u"Genbu", 22},
			ShimamonFightersText{u"Heja Pu Lady",
				u"Full Rumor Alchemist", nullptr, -1},
			ShimamonFightersText{u"Candy Lady",
				u"The Eternal Empress", nullptr, -1},
			ShimamonFightersText{u"Diner Guy",
				u"Won Iron Chef that one time", nullptr, -1},
			ShimamonFightersText{u"Lone Angler",
				u"Self-proclaimed lone fisher", nullptr, -1},
			ShimamonFightersText{u"Stall Guy",
				u"Wanted to become a 3★ cook", nullptr, 24},
			ShimamonFightersText{u"Sky Boy",
				u"Fated to eternal heartbreak", nullptr, -1},
			ShimamonFightersText{u"Sea Boy",
				u"Poseidon's Successor", nullptr, -1},
			ShimamonFightersText{u"Land Boy",
				u"Horizon Child", nullptr, -1},
			ShimamonFightersText{u"Sky Maiden",
				u"Guardian of Love's Prison", nullptr, -1},
			ShimamonFightersText{u"Sea Maiden",
				u"Bearer of the Dark Archive", nullptr, -1},
			ShimamonFightersText{u"Land Maiden",
				u"Shimamon Fighter", nullptr, -1},
			ShimamonFightersText{u"Nosy Lady",
				u"A woman in her later years", nullptr, -1},
			ShimamonFightersText{u"Worried Lady",
				u"Calls talk shows as '666'", nullptr, -1},
			ShimamonFightersText{u"Rumor-monger",
				u"Former biker queen", nullptr, -1},
			ShimamonFightersText{u"Fisherman A",
				u"Hunter on land and sea", nullptr, -1},
			ShimamonFightersText{u"R.Cal. Guy",
				u"Never misses a transmission", nullptr, -1},
			ShimamonFightersText{u"YAA Captain",
				u"The island's biggest loser", nullptr, -1},
			ShimamonFightersText{u"YAA ViceCap",
				u"Love Hunter", nullptr, -1},
			ShimamonFightersText{u"Tokuda",
				u"Dazzling Prince", nullptr, -1},
			ShimamonFightersText{u"Teacher",
				u"Former foreign soldier", nullptr, -1},
			ShimamonFightersText{u"Local Turtle",
				u"Beat a rabbit in its dream", nullptr, -1},
			ShimamonFightersText{u"Old Dog",
				u"Soldier from the northeast", nullptr, -1},
			ShimamonFightersText{u"Stray Cat",
				u"Loves to sing and dance", nullptr, -1},
			ShimamonFightersText{u"Shiki",
				u"She Who Shall Not Work", nullptr, -1}
		};

		const char16_t* FIGHTERS_LOCATIONS[] = {
			u"Harbor",
			u"Candy Store",
			u"Shrine",
			u"Diner",
			u"Elementary Pool",
			u"Secret Base",
			u"Beach",
			u"Residential Street",
			u"Main Street",
			u"Rural Path",
			u"Mountain path",
			u"Mountain path",
			u"Beach",
			u"Island Outskirts",
			u"Pond",
			u"Entrance",
			u"Living Room",
			u"Kitchen",
			u"Shed",
			u"？？？",
			u"Clinic",
			u"Cavern Entrance",
			u"Bay",
			u"Lighthouse"
		};

		const char16_t* ATTACKS[] = {
			u"Hopper",
			u"Song",
			u"Scythe",
			u"Air Slice",
			u"Stink Bomb",
			u"Curl Up",
			u"Call Friends",
			u"Tongue Lash",
			u"Ink Spray",
			u"Scissor Attack",
			u"Numbing Needle",
			u"Scale Spray",
			u"Poison Needle",
			u"Peck",
			u"Fang",
			u"Slime Spray",
			u"Bite",
			u"Claw",
			u"Swallow",
			u"Thorn Guard",
			u"Tackle",
			u"Ultrasonic Wave",
			u"Bloodsucker",
			u"Inari Attack",
			u"Purge",
			u"Rumble",
			u"Roar",
			u"Fly",
			u"Legendary Shadow Soul Majestic Leo Cannon of Desire",
			u"Solo Beast Squats",
			u"Ultra Recovery",
			u"Crunch",
			u"Double Jump",
			u"Harden",
			u"Shell Guard",
			u"Wing Flap",
			u"Constrict",
			u"Bind",
			u"Hydro Gladiator Kai",
			u"Beast Squats",
			u"Mysterious Dance",
			u"Naked Festival"

		};

		std::unordered_map<UTF16_lambda> sprintf16_formats = {
			{u"ランキング %d位",
				u"Rank #%d"},
			{u"%2d勝%2d敗",
				u"%2dW %2dL"},
			{u"%sを選択した！",
				u"%s, I choose you!"},
			{u"%sは%sを選択した！",
				u"%s: %s, I choose you!"},
			{u"$C[ffff00]フィールド属性効果$C[]",
				u"$C[ffff00]Environmental Effect$C[]"},
			{u"%sの%sが少し$C[ff0000]強く$C[]なった！",
				u"%s's %s has become slightly $C[ff0000]stronger$C[]!"},
			{u"%sは戦意を$C[ffff00]喪失している$C[]！",
				u"%s has lost its $C[ffff00]will to fight$C[]!"},
			{u"%sは$C[0000ff]自動回復$C[]が解除された！",
				u"%s's $C[0000ff]self-recovery$C[] has stopped!"},
			{u"%sは$C[00ff00]自動回復$C[]が付与されている！",
				u"%s has gained the effect of $C[00ff00]self-recovery$C[]!"},
			{u"体力を$C[00ff00]%d$C[]回復した！",
				u"$C[00ff00]%d$C[] HP recovered!"},
			{u"%sの$C[00ff00]仲間$C[]の$C[ff0000]攻撃$C[]！",
				u"%s's $C[00ff00]comrade$C[] $C[ff0000]attacks$C[]!"},
			{u"%sに$C[ff0000]%d$C[]のダメージ！",
				u"%s received $C[ff0000]%d$C[] damage!"},
			{u"しかし、$C[ff0000]当たらなかった$C[]！",
				u"But, $C[ff0000]it missed$C[]!"},
			{u"$C[ffff00]クリティカルダメージ！$C[]",
				u"$C[ffff00]A critical hit!$C[]"},
			{u"$C[ff0000]%d$C[]のダメージを受けた！",
				u"$C[ff0000]%d$C[] damage taken!"},
			{u"%sの$C[ffff00]ダメージ反射$C[]！",
				u"%s $[ffff00]reflects some damage$C[]!"},
			{u"%sの$C[00ff00]仲間$C[]は飽きて$C[ff00ff]帰って$C[]いった！",
				u"%s' $C[00ff00]comrade$C[] is tired $C[ff00ff]and returns home$C[]!"},
			{u"%sは$C[0000ff]ダメージ軽減$C[]が解除された！",
				u"%s's $C[0000ff]damage reduction was lifted$C[]!"},
			{u"%sは$C[0000ff]ダメージ反射$C[]が解除された！",
				u"%s's $C[0000ff]damage reflection was lifted$C[]!"},
			{u"%sは$C[ffff00]身を守り$C[]続けている！",
				u"%s $C[ffff00]continues to protect itself$C[]!"},
			{u"%sは$C[00ff00]目を覚ました$C[]！",
				u"%s $C[00ff00]woke up$C[]!"},
			{u"%sは$C[ffff00]目を覚ました$C[]！",
				u"%s $C[ffff00]woke up$C[]!"},
			{u"%sは$C[ffff00]寝ぼけている$C[]！",
				u"%s $C[ffff00]is sleepy$C[]!"},
			{u"%sは$C[0000ff]眠っている$C[]！",
				u"%s $C[0000ff]is asleep$C[]!"},
			{u"%sは$C[ffff00]目を回している$C[]！",
				u"%s is $C[ffff00]stunned$C[]!"},
			{u"%sは体が$C[ffff00]痺れて$C[]動けない！",
				u"%s is $C[ffff00]numb$C[], and cannot move!"},
			{u"%sは$C[ff00ff]毒$C[]が付与されている！",
				u"%s was affected by the $C[ff00ff]poison$C[]!"},
			{u"%sは$C[ff00ff]毒$C[]によって$C[ff0000]力尽きた$C[]！",
				u"%s fainted $C[ff00ff]due to$C[] the $C[ff0000]poison$C[]!"},
			{u"%sは$C[ffff00]我に返った！$C[]",
				u"%s $C[ffff00]came to its senses!$C[]"},
			{u"%sは$C[ff0000]怒っている$C[]！",
				u"%s $C[ff0000]is angry$C[]!"},
			{u"攻撃の$C[00ff00]命中率$C[]が大幅に$C[0000ff]下がった$C[]！",
				u"$C[00ff00]Accuracy$C[] of all attacks $C[0000ff]dropped significantly$C[]!"},
			{u"%sは$C[ff0000]通常攻撃$C[]を繰り出した！",
				u"%s $C[ff0000]unleashed$C[] an attack!"},
			{u"%sは$C[ff0000]ぼーっ$C[]としている！",
				u"%s is $C[ff0000]confused$C[]!"},
			{u"%sは$C[ff0000]自分に攻撃している$C[]！",
				u"%s $C[ff0000]hurt itself$C[]!"},
			{u"%sは$C[ff0000]力尽きた$C[]！",
				u"%s was $C[ff0000]defeated$C[]!"},
			{u"%sは涙を$C[ffff00]流し$C[]尽くした！",
				u"%s stopped $C[ffff00]crying$C[]!"},
			{u"%sは涙を$C[ffff00]流している$C[]！",
				u"%s is $C[ffff00]crying$C[]!"},
			{u"%sは$C[ffff00]目が見える$C[]ようになった！",
				u"%s regained $C[ffff00]its sight$C[]!"},
			{u"%sは$C[0000ff]目が曇っている$C[]！",
				u"%s was $C[0000ff]blinded$C[]!"},
			{u"%sは$C[ffff00]ぬめり$C[]がとれた！",
				u"%s $C[ffff00]shook off the slime!$C[]!"},
			{u"%sは滑って$C[ffff00]転んだ$C[]！",
				u"%s slipped and $C[ffff00]fell$C[]!"},
			{u"%sは遠慮するのを$C[ffff00]止めた$C[]！",
				u"%s overcame its $C[ffff00]hesitation$C[]!"},
			{u"%sは$C[0000ff]遠慮$C[]をしている！",
				u"%s $C[0000ff]hesitated$C[]!"},
			{u"$C[00ff00]攻撃力$C[]が大幅に$C[0000ff]下がった$C[]！",
				u"$C[00ff00]Attack$C[] $C[0000ff]dropped significantly$C[]!"},
			{u"%sはテンションが$C[0000ff]下がってきた$C[]！",
				u"%s's $C[0000ff]tension dropped$C[]!"},
			{u"%sはテンションが$C[ffff00]上がっている$C[]！",
				u"%s's $C[ffff00]tension rose$C[]!"},
			{u"$C[00ff00]攻撃力$C[]が大幅に$C[ff0000]上がった$C[]！",
				u"$C[00ff00]Attack$C[] $C[ff0000]increased significantly$C[]!"},
			{u"$C[00ff00]防御力$C[]が大幅に$C[ff0000]上がった$C[]！",
				u"$C[00ff00]Defense$C[] $C[ff0000]increased significantly$C[]!"},
			{u"%sの$C[00ff00]%s$C[]！",
				u"%s used $C[00ff00]%s$C[]!"},
			{u"%sの攻撃！",
				u"%s attacks!"},
			{u"属性$C[ffff00]有利$C[]攻撃！",
				u"Its type is at an $C[ffff00]advantage$C[]!"},
			{u"属性$C[0000ff]不利$C[]攻撃！",
				u"Its type is at a $C[0000ff]disadvantage$C[]!"},
			{u"しかし、$C[ff0000]失敗$C[]した！",
				u"But, $C[ff0000]it messed up$C[]!"},
			{u"徐々にＨＰが$C[00ff00]回復$C[]する！",
				u"Its HP starts to slowly $C[00ff00]recover$C[]!"},
			{u"しかし、$C[ff0000]誰も$C[]来なかった！",
				u"But, $C[ff0000]nobody$C[] came!"},
			{u"$C[00ff00]仲間$C[]が集まってきた！",
				u"$C[00ff00]Comrades$C[] appeared!"},
			{u"受けるダメージを$C[ffff00]軽減$C[]する！",
				u"The damage was $C[ffff00]reduced$C[]!"},
			{u"通常攻撃で受けるダメージを$C[ffff00]反射$C[]する！",
				u"Some of the attack's damage got $C[ffff00]reflected$C[]!"},
			{u"%sは$C[00ff00]%d$C[]回復した！",
				u"%s recovered $C[00ff00]%d$C[] HP!"},
			{u"%sに$C[ffff00]痺れ$C[]を与えた！",
				u"$s was affected by $C[ffff00]paralysis$C[]!"},
			{u"%sは$C[ffff00]気絶$C[]した！",
				u"%s is $C[ffff00]stunned$C[]!"},
			{u"%sは$C[ff0000]怒った$C[]！",
				u"%s has became $C[ff0000]angry$C[]!"},
			{u"%sは$C[ff00ff]目が眩んだ$C[]！",
				u"%s was affected by $C[ff00ff]blindness$C[]!"},
			{u"%sは$C[ffff00]ぬるぬる$C[]している！",
				u"%s was covered in $C[ffff00]slime$C[]!"},
			{u"%sは$C[ffff00]混乱$C[]している！",
				u"%s inflicts $C[ffff00]confusion$C[]!"},
			{u"$C[ff0000]戦闘終了！\n判定勝負＝残りＨＰの割合が多いほうが勝利する!$C[]",
				u"$C[ff0000]The battle is over!\nThe combatant with the higher percentage of HP wins!$C[]"},
			{u"$C[ff0000]%s$C[]の$C[00ff00]%s$C[]が勝利した！",
				u"$C[ff0000]%s$C[]'s $C[00ff00]%s$C[] wins!"},
			{u"%sは%sを選択した！",
				u"%s sends out %s!"},
			{u"%sを選択した！",
				u"%s goes into battle!"},
			{u"$C[ffff00]フィールド属性効果$C[]",
				u"$C[ffff00]Field buff active!$C[]"},
			{u"%sは$C[0000ff]眠って$C[]しまった！",
				u"%s fell $C[0000ff]asleep$C[]!"},
			{u"設置できるエサの最大数が%d→%dにレベルアップした！",
				u"Your maximum number of bait sites has leveled up from %d to %d!"},
			{u"『%s』を地図に書き加えた！",
				u"\"%s\" has been added to the map!"},
			{u"%sは呼応してテンションが上がっている！",
				u"%s is raring to fight!"},
			{u"%sは戦意を喪失している！",
				u"%s's spirits fell!"},
			{u"%sはテンションが下がっている！",
				u"%s lost his fighting spirit!"},
			{u"%sは精神的なダメージを受けている！",
				u"%s took critical psychological damage!"},
			{u"%sは天善に呼応してテンションが上がっている！",
				u"%s is hyped up by Tenzen's encouragement!"},
			{u"%sはテンションが$C[ffff00]下がっている$C[]！",
				u"%s's $C[ffff00]tension dropped$C[]!"},
			{u"%sはテンションが$C[ffff00]上がってきた$C[]！",
				u"%s's $C[ffff00]tension rose$C[]!"},
			{u"%sはテンションが上がっている！",
				u"%s gets super hyped up!"},
			{u"$C[ff0000]戦闘終了！\n判定勝負＝残りＨＰの割合が多いほうが勝利する！$C[]",
				u"$C[ff0000]The battle is over!\nThe combatant with the higher percentage of HP wins!$C[]"},
			{u"%sは戦闘不能になった！",
				u"%s was knocked out!"},
			{u"『%s』がランキングに参戦した！",
				u"\"%s\" has joined the fight!"},
			{u"試合数:%d",
				u"Battles:%d"},
			{u"勝利数:%d",
				u"Victories:%d"},
			{u"与えたダメージ:%d",
				u"Damage Dealt:%d"}
		};
	}

	namespace SHIMAPONG {

		const char16_t* TableStandardPopups1[] = {
			u"The scale of your shot icons was increased!",
			u"The number of shot icons was reduced!",
			u"Hit timing will be judged more generously!",
			u"Your HP is automatically regenerating!",
			u"Your equipment's durability is regenerating!",
			u"Your opponent's super shot has been sealed!",
			u"Your shots will deal more damage!",
			u"You will take less damage!",
			u"Your shots will deal massive damage! Shot icon scale reduced!",
			u"A damage-preventing shield is protecting you!",
			u"Your super shots will charge faster!",
			u"The target of the enemy team's shots will be visible!",
			u"You entered the Everlasting Moment!",
			u"The 'Cursed' title activates! The curse is spreading...!",
		};

		const char16_t* TableStandardPopups2[] = {
			u"The scale of your shot icons was reduced!",
			u"The number of shot icons was increased!",
			u"Hit timing will be judged more severely!",
			u"Your HP is automatically decreasing!",
			u"Your equipment's durability is automatically decreasing!",
			u"Your super shot has been sealed!",
			u"The enemy team's shots will deal more damage!",
			u"The enemy team will take less damage!",
			u"Enemy shots will deal massive damage! Shot icon scale increased!",
			u"A damage-preventing shield is protecting the enemy!",
			u"Your super shots will charge slower!",
			u"The target of the enemy team's shots will be obfuscated!",
			u"You entered the Everlasting Moment!",
			u"The 'Cursed' title activates! The curse is spreading...!"
		};

		const char16_t* TableStandardPopups3[] = {
			u"Your zones are fighting for dominance!",
			u"Ping-pong free matches unlocked!",
			u"Ping-pong free doubles matches unlocked!",
			u"The ball is spinning violently!",
			u"A damage-blocking shield has been raised!",
			u"？？？ appeared!",
			u"Umi summoned a Jewel Caterpillar!",
			u"Umi summoned the Master!",
			u"The Master unleashes an earth-shaking roar!",
			u"Umi summoned Genbu!",
			u"Genbu hit a power shot!",
			u"Nomiki grew massive!",
			u"Kyouko is enveloped in dazzling light...!",
			u"Kyouko is young again!",
			u"Kyouko has returned to normal!",
			u"Ryouichi is enveloped in dazzling light...!",
			u"Ryouichi duplicated himself!",
			u"Received an oldschool racket!",
			u"Tenzen is enveloped in an ominous aura...!",
			u"Return all shots with an Excellent rating!",
			u"Your cowardly shot enrages Tenzen...!",
			u"Tenzen unleashes his true power...!",
			u"Hairi rises up to meet that power...!",
			u"Power courses through you!",
			u"The opponent's icon's super count was reset!",
			u"The opponent's icon was afflicted with deadly poison!",
		};

		const char16_t* TableStandardPopups4[] = {
			u"The shot icon was afflicted with poison!",
			u"The shot icon was afflicted with paralysis!",
			u"The shot icon was cursed!",
			u"The shot icon's super count was reset!",
			u"The shot icon was afflicted with deadly poison!",
			u"Your super shot was sealed!",
			u"The shot icon shrunk!",
			u"The shot icon was afflicted with charm!"
		};

		const std::unordered_map<UTF8_lambda> DifficultyPopup = {
			{"ＥＡＳＹが選択されました。カーソルは自動的に移動します。",
				"EASY was selected. The cursor will move automatically."},
			{"ＮＯＲＭＡＬが選択されました。カーソルはプレーヤーが操作します。",
				"NORMAL was selected. The cursor is controlled by the player."}
		};

		const std::unordered_map<UTF8_lambda> FreeMatchPopup = {
			{"$A1「START」で試合を開始します。\n"
			"$S001 \n"
			"$S024画面上部の「試合設定」で相手の強さ、「難易度」で操作の難易度を変更できます。",
				"$A1Press \"START\" to start the match.\n"
				"$S001 \n"
				"$S024You can change the opponent's strength with \"GAME\" setting at the top of the screen,\n"
				"and the difficulty of operating cursor with \"MODE\"."},
			{"$A1試合形式を選べます。\n"
			"$S001 \n"
			"$S024１対１のシングルスと、２対２のダブルスがプレイできます。\n"
			"「SINGLES」をＡボタンやタップで切り替えてください。",
				"$A1You can choose the type of match.\n"
				"$S001 \n"
				"$S024You can play 1 vs 1 \"singles\" and 2 vs 2 \"doubles\".\n"
				"Press A or tap on \"SINGLES\" to change type."},
			{"$A1対戦相手を選んでください。\n"
			"$S001 \n"
			"$S024Ａボタンやタップで決定します。\n"
			"決定後はＢボタンやタッチアンドホールドでキャンセルできます。\n"
			"「RANDOM」は自動で対戦相手が決まります。",
				"$A1Choose your opponent.\n"
				"$S001 \n"
				"$S024Confirm with A button or tap.\n"
				"You can cancel it later with the B button or touch and hold.\n"
				"\"RANDOM\" will choose opponent automatically."},
			{"$A1パートナーを選んでください。\n"
			"$S001 \n"
			"$S024Ａボタンやタップで決定します。\n"
			"決定後はＢボタンやタッチアンドホールドでキャンセルできます。\n"
			"「RANDOM」は自動でパートナーが決まります。",
				"$A1Please choose a partner.\n"
				"$S001 \n"
				"$S024Confirm with the A button or tap.\n"
				"You can cancel it later with the B button or touch and hold.\n"
				"\"RANDOM\" will choose partner automatically."},
			{"１人目の対戦相手を選んでください。",
				"Choose your first opponent."},
			{"２人目の対戦相手を選んでください。",
				"Choose your second opponent."}
		};

		const std::unordered_map<UTF16_lambda> PlayerStatus = {
			{u"はショットを打ち返してきた！",
				u" returned the shot!"},
			{u"は応戦している！",
				u" returned fire!"},
			{u"は状態異常を防いだ！",
				u" shook off a status ailment!"},
			{u"がダブルスのパートナー候補になった！",
				u" became a doubles partner candidate!"},
			{u"は正気に戻った！",
				u" shook the curse off!"},
			{u"は異世界に連れて行かれた！",
				u" was taken away to another world!"},
			{u"は体力が回復した！",
				u" was healed!"},
			{u"のダイレクトアタック！",
				u" attacks directly!"},
			{u"はお腹を空かせている！",
				u" got hungry!"},
			{u"はボールを高く打ち上げてしまった！",
				u" accidentally lobbed the ball!"},
			{u"は戦闘不能になった！",
				u" was incapacitated!"},
			{u"はゾーンを展開した！",
				u" activated a zone!"},
			{u"はピンチで能力が大幅にアップ！",
				u" powers up in a last-ditch effort!"},
			{u"は吹っ飛んでいった！",
				u" was blown away!"},
			{u"は呪いが伝染した！",
				u" was infected by the curse!"},
			{u"は復帰した！",
				u" returned to the battle!"},
			{u"は魅了されている！",
				u" was charmed!"},

		};

		const char16_t* EndConString = u"!";

		struct standardText {
			const char16_t* JPN;
			const char16_t* ENG;
		};

		const char16_t* no = u"'s ";
		std::array wa = {
			standardText{u"を拾った！",
				u" picked up the "},
			standardText{u"を落とした！",
				u" dropped the "}
		};
		const char16_t* kara = u" gave you ";

		std::array AfterItemsConStrings = {
			standardText{u"では耐えきれない！",
				u" couldn't withstand the blow!"},
			standardText{u"は砕け散った！",
				u" broke into pieces!"},
			standardText{u"はバラバラになった！",
				u" was scattered to the winds!"},
			standardText{u"は壊れた！",
				u" broke!"},
			standardText{u"はボコボコになった！",
				u" was horribly dented!"},
			standardText{u"に呪いが降りかかる…！",
				u" cursed you...!"},
			standardText{u"はバラバラになった！",
				u" fell to pieces!"},
			standardText{u"の残弾がなくなった！",
				u" ran out of ammo!"},
			standardText{u"は状態異常を防いだ！",
				u" shook off a status ailment!"}
		};

		std::array ItemsConStrings = {
			standardText{u"ラケット",
				u"racket"},
			standardText{u"素手",
				u"Bare Hands"},
			standardText{u"スイカバー",
				u"Watermelon Bar"},
			standardText{u"ちょっとＨな本",
				u"Lewd Magazine"},
			standardText{u"トランク",
				u"Suitcase"},
			standardText{u"パリングルス",
				u"Paringles Can"},
			standardText{u"フライパン",
				u"Frying Pan"},
			standardText{u"怪しげな人形",
				u"Suspicious Doll"},
			standardText{u"良一のボディ",
				u"Ryouichi's Body"},
			standardText{u"思い出のラケット",
				u"Old-School Racket"},
			standardText{u"ハイドログラディエーター改",
				u"Hydro Gladiator Kai"},
			standardText{u"猫にゃん棒",
				u"Kitty Paw Rod"},
			standardText{u"己の拳",
				u"Your Fist"},
			standardText{u"おむすび",
				u"Omusubi"},
			standardText{u"王のラケット",
				u"King's Racket"}
		};

		const std::unordered_map<UTF16_lambda> PlayerAttacks = {
			{u"の堕天流・封印包帯", 
				u" used Fallen Angel Style - Bandage of Sealing!"},
			{u"の届け…、白鷺の囀り", 
				u" used Reach, O' Warble of the White Heron!"},
			{u"のローリングジェット", 
				u" used Rolling Jet!"},
			{u"のホスト妙技・壁打挟撃", 
				u" used Host Arts - Kabedon!"},
			{u"の人よ己を知れ", 
				u" used Know your place, Human!"},
			{u"のスーパーリターンショット", 
				u" used Super Return Shot!"},
			{u"の堕天流・暗黒書架", 
				u" used Fallen Angel Style - Bookcase of Darkness!"},
			{u"の堕天流・幻想隣人", 
				u" used Fallen Angel Style - Illusory Neighbor!"},
			{u"の舞え…、黎鶴の囀り", 
				u" used Dance, O' Chirrup of the Atramentous Crane!"},
			{u"の導け…、大鵬の翼よ", 
				u" used Lead, O' Wings of the Magnificent Firebird!"},
			{u"のギャラクティカブーメラン", 
				u" used Galactic Boomerang!"},
			{u"のハリケーンサンダー", 
				u" used Hurricane Thunder!"},
			{u"のホスト妙技・甘噛み", 
				u" used Host Arts - Luscious Bite!"},
			{u"のホスト妙技・小指絡め", 
				u" used Host Arts - Entwined Pinkies!"},
			{u"の卓球あれ", 
				u" used Let There be Table Tennis!"},
			{u"の崇めよ…", 
				u" used Worship me...!"},
			{u"の鳴瀬流・鳴瀬の渦潮", 
				u" used Naruse Style - Naruse's Raging Vortex!"},
			{u"の空門流・胡蝶の夢", 
				u" used Sorakado Style - Butterfly's Dream!"},
			{u"のテトロドキドキン", 
				u" used Tetro-doki-doki-toxin!"},
			{u"のヴェンダース流『封』", 
				u" used Wenders Style - Seal!"},
			{u"のチャーハン・オブ・薬膳", 
				u" used Medicinal Fried Rice!"},
			{u"の加藤流・初ノ呪", 
				u" used Katou Style - First Curse!"},
			{u"の加藤流・玖ノ呪", 
				u" used Katou Style - Ninth Curse!"},
			{u"のエネミーパージ", 
				u" used Enemy Purge!"},
			{u"の奥義・魂伝影念獅坐威砲", 
				u" used Legendary Shadow Soul Majestic Leo Cannon of Desire!"},
			{u"の奥義・舞卦処撥斗", 
				u" used Secret Technique - Dancing Strike of Divine Denial!"},
			{u"の奥義・六波羅反台", 
				u" used Secret Technique - Six Virtues of Enlightenment!"},
			{u"のハイドロ卓球モード", 
				u" used Hydro - Ping-Pong Mode!"},
			{u"のバスト殺法・魅惑の舞", 
				u" used Bust Buster - Captivating Dance!"},
			{u"の玄武砲", 
				u" used Genbu Cannon!"},
			{u"の妙薬・御夢主毘", 
				u" used Miracle Cure - Ethereal Omusubi!"},
			{u"の絶対蒼守護ノ威圧", 
				u" used Absolute Ao Protection Aura!"},
			{u"の天伝加納真卓流・封還", 
				u" used Kanou Ascendant: True Ping-Pong Arts - Sealing Return!"},
			{u"の天伝加納真卓流・架燈", 
				u" used Kanou Ascendant: True Ping-Pong Arts - Lamp Stand!"},
			{u"の天伝加納真卓流・雷泰", 
				u" used Kanou Ascendant: True Ping-Pong Arts - Raging Lightning!"},
			{u"の天閃", 
				u" used Heavenly Flash!"},
			{u"の堕天流・妖睛解放", 
				u" used Fallen Angel Style - Unsealed Demon-Eye!"},
			{u"の愛よ…、鳳凰と共に", 
				u" used Love, O' Union of the Flame Phoenix!"},
			{u"のウィニング・ザ・ファントム", 
				u" used Winning the Phantom!"},
			{u"のホスト妙技・三変酒塔", 
				u" used Host Arts - Champagne Tower!"},
			{u"の卓球創造", 
				u" used Genesis of Table Tennis!"},
			{u"の超れいだん", 
				u" used Super Spirit Gun!"},
			{u"の空門秘奥・夢幻忘却", 
				u" used Sorakado Secret Arts - Fantastical Oblivion!"},
			{u"のひげ猫団一斉砲撃", 
				u" used Catpaw Whiskerneers - Broadside Bombardment!"},
			{u"のヴェンダース流奥義『パロプンテ』", 
				u" used Wenders Style Secret Arts - Hocus Pocus!"},
			{u"の島モン召喚", 
				u" used Shimamon Summoning!"},
			{u"の加藤流・壱拾参ノ呪", 
				u" used Katou Style - Curse of Thirteen!"},
			{u"の加藤流・裏七ノ呪", 
				u" used Katou Style - Curse of Inverted Seven!"},
			{u"の裸祭り", 
				u" used Naked Festival!"},
			{u"の秘奥義・天全", 
				u" used Extra Secret Technique - Tenzen Omnipotent!"},
			{u"の執行部の覇気", 
				u" used Executive Spirit!"},
			{u"のバスト殺法秘技・π", 
				u" used Bust Buster - π!"},
			{u"の四神嵐舞", 
				u" used Storm-Dance of the Four Divine Beasts!"},
			{u"の神山之絶技・鬼魂満腹弾", 
				u" used Kamiyama Style Special Move: Satiated Oni Soul Shot!"},
			{u"の絶招・威鳴狸", 
				u" used Absolute Summoning - Ultimate Beast Inari!"},
			{u"の天伝加納真卓流零式・無垓", 
				u" used Kanou Ascendant: Origin Form - Transcendent Nil!"},
			{u"のドラゴンスレイブ", 
				u" used Dragon-slave!"},
			{u"のスマッシュ", 
				u" used Smash!"},
			{u"のダミーショット", 
				u" used Dummy shot!"},
			{u"のラリースキルショット",
				u" used Rally skill shot!"}
		};

		const std::unordered_map<UTF16_lambda> FinishShot = {
			{u"堕天流・封印包帯", 
				u"Fallen Angel Style - Bandage of Sealing"},
			{u"届け…、白鷺の囀り", 
				u"Reach, O' Warble of the White Heron"},
			{u"ローリングジェット", 
				u"Rolling Jet"},
			{u"ホスト妙技・壁打挟撃", 
				u"Host Arts - Kabedon"},
			{u"人よ己を知れ", 
				u"Know your place, Human"},
			{u"スーパーリターンショット", 
				u"Super Return Shot"},
			{u"堕天流・暗黒書架", 
				u"Fallen Angel Style - Bookcase of Darkness"},
			{u"堕天流・幻想隣人", 
				u"Fallen Angel Style - Illusory Neighbor"},
			{u"舞え…、黎鶴の囀り", 
				u"Dance, O' Chirrup of the Atramentous Crane"},
			{u"導け…、大鵬の翼よ", 
				u"Lead, O' Wings of the Magnificent Firebird"},
			{u"ギャラクティカブーメラン", 
				u"Galactic Boomerang"},
			{u"ハリケーンサンダー", 
				u"Hurricane Thunder"},
			{u"ホスト妙技・甘噛み", 
				u"Host Arts - Luscious Bite"},
			{u"ホスト妙技・小指絡め", 
				u"Host Arts - Entwined Pinkies"},
			{u"卓球あれ", 
				u"Let There be Table Tennis"},
			{u"崇めよ…", 
				u"Worship me..."},
			{u"鳴瀬流・鳴瀬の渦潮", 
				u"Naruse Style - Naruse's Raging Vortex"},
			{u"空門流・胡蝶の夢", 
				u"Sorakado Style - Butterfly's Dream"},
			{u"テトロドキドキン", 
				u"Tetro-doki-doki-toxin"},
			{u"ヴェンダース流『封』", 
				u"Wenders Style - Seal"},
			{u"チャーハン・オブ・薬膳", 
				u"Medicinal Fried Rice"},
			{u"加藤流・初ノ呪", 
				u"Katou Style - First Curse"},
			{u"加藤流・玖ノ呪", 
				u"Katou Style - Ninth Curse"},
			{u"エネミーパージ", 
				u"Enemy Purge"},
			{u"奥義・魂伝影念獅坐威砲", 
				u"Legendary Shadow Soul Majestic Leo Cannon of Desire"},
			{u"奥義・舞卦処撥斗", 
				u"Secret Technique - Dancing Strike of Divine Denial"},
			{u"奥義・六波羅反台", 
				u"Secret Technique - Six Virtues of Enlightenment"},
			{u"ハイドロ卓球モード", 
				u"Hydro - Ping-Pong Mode"},
			{u"バスト殺法・魅惑の舞", 
				u"Bust Buster - Captivating Dance"},
			{u"玄武砲", 
				u"Genbu Cannon"},
			{u"妙薬・御夢主毘", 
				u"Miracle Cure - Ethereal Omusubi"},
			{u"絶対蒼守護ノ威圧", 
				u"Absolute Ao Protection Aura"},
			{u"天伝加納真卓流・封還", 
				u"Kanou Ascendant: True Ping-Pong Arts - Sealing Return"},
			{u"天伝加納真卓流・架燈", 
				u"Kanou Ascendant: True Ping-Pong Arts - Lamp Stand"},
			{u"天伝加納真卓流・雷泰", 
				u"Kanou Ascendant: True Ping-Pong Arts - Raging Lightning"},
			{u"天閃", 
				u"Heavenly Flash"},
			{u"堕天流・妖睛解放", 
				u"Fallen Angel Style - Unsealed Demon-Eye"},
			{u"愛よ…、鳳凰と共に", 
				u"Love, O' Union of the Flame Phoenix"},
			{u"ウィニング・ザ・ファントム", 
				u"Winning the Phantom"},
			{u"ホスト妙技・三変酒塔", 
				u"Host Arts - Champagne Tower"},
			{u"卓球創造", 
				u"Genesis of Table Tennis"},
			{u"超れいだん", 
				u"Super Spirit Gun"},
			{u"空門秘奥・夢幻忘却", 
				u"Sorakado Secret Arts - Fantastical Oblivion"},
			{u"ひげ猫団一斉砲撃", 
				u"Catpaw Whiskerneers - Broadside Bombardment"},
			{u"ヴェンダース流奥義『パロプンテ』", 
				u"Wenders Style Secret Arts - Hocus Pocus"},
			{u"島モン召喚", 
				u"Shimamon Summoning"},
			{u"加藤流・壱拾参ノ呪", 
				u"Katou Style - Curse of Thirteen"},
			{u"加藤流・裏七ノ呪", 
				u"Katou Style - Curse of Inverted Seven"},
			{u"裸祭り", 
				u"Naked Festival"},
			{u"秘奥義・天全", 
				u"Extra Secret Technique - Tenzen Omnipotent"},
			{u"執行部の覇気", 
				u"Executive Spirit"},
			{u"バスト殺法秘技・π", 
				u"Bust Buster - π"},
			{u"四神嵐舞", 
				u"Storm-Dance of the Four Divine Beasts"},
			{u"神山之絶技・鬼魂満腹弾", 
				u"Kamiyama Style Special Move: Satiated Oni Soul Shot"},
			{u"絶招・威鳴狸", 
				u"Absolute Summoning - Ultimate Beast Inari"},
			{u"天伝加納真卓流零式・無垓", 
				u"Kanou Ascendant: Origin Form - Transcendent Nil"},
			{u"ドラゴンスレイブ", 
				u"Dragon-slave"},
			{u"スマッシュ", 
				u"Smash"},
			{u"ダミーショット", 
				u"Dummy shot"},
			{u"ラリースキルショット",
				u"Rally skill shot"},
			{u"ショットミス",
				u"Missed shot"},
			{u"ノーマルショット",
				u"Normal shot"},
			{u"サービスエース",
				u"Service ace"},
			{u"スマッシュミス",
				u"Missed smash"}
		};

		std::array PLAYERS = {
			standardText{u"鷹原羽依里", u"Takahara Hairi"},
			standardText{u"鳴瀬しろは", u"Naruse Shiroha"},
			standardText{u"空門蒼", u"Sorakado Ao"},
			standardText{u"久島鴎", u"Kushima Kamome"},
			standardText{u"紬ヴェンダース", u"Tsumugi Wenders"},
			standardText{u"うみ", u"Umi"},
			standardText{u"岬鏡子", u"Misaki Kyouko"},
			standardText{u"三谷良一", u"Mitani Ryouichi"},
			standardText{u"加納天善", u"Kanou Tenzen"},
			standardText{u"野村美希", u"Nomura Miki"},
			standardText{u"水織静久", u"Mizuori Shizuku"},
			standardText{u"玄武", u"Genbu"},
			standardText{u"神山識", u"Kamiyama Shiki"},
			standardText{u"加納天善", u"Kanou Tenzen"},
			standardText{u"イナリ", u"Inari"},
			standardText{u"空門藍", u"Sorakado Ai"},
			standardText{u"ツムギ", u"Tsumugi"},
			standardText{u"強面の老人", u"Scary Old Man"}, // 11 Alt
			standardText{u"満月を喰らいし乳房さん", u"Abreast of the Moon"}, //10 Alt
		};

		const std::unordered_map<UTF16_lambda> DOUBLES = {
			{u"ぼっち＝最強伝説",
				u"The Ultimate Loner Legend"},
			{u"空を行くピンクバード",
				u"Pervy Bard of the Blue Sky"},
			{u"鴎団",
				u"Kamome Brigade"},
			{u"ヴェンダースさんと加藤さんの孫",
				u"Grandchildren of Wenders and Katou"},
			{u"幼女の鉄壁",
				u"Iron Wall of Youth"},
			{u"加藤流正統伝承者",
				u"Passing Down of the Katou Style"},
			{u"ザ・ネイキッズ",
				u"The Nekkids"},
			{u"スカイ・ホーク",
				u"Sky + Hawk"},
			{u"鳥白島少年団卓球推進部",
				u"Torishirojima Y.A. Ping-pong Division"},
			{u"北方守護継承試練中",
				u"Genbu's Probationary Exam"},
			{u"おむすび同盟",
				u"Omusubi Union"},
			{u"タカモメ団",
				u"Taka-mome Brigade"},
			{u"ザ★チャーハンズ",
				u"The Rice★Fryers"},
			{u"孤独のスナイパー",
				u"The Lonesome Snipers"},
			{u"鳴瀬家の覇道",
				u"Might of the Naruse Clan"},
			{u"大胆むっつり",
				u"Sullen Audacity"},
			{u"富岳蒼天",
				u"Blue Sky Above the Mountains"},
			{u"鳥白島少年団＜乱＞",
				u"Rebels of the Youth Association"},
			{u"黄昏を歩む者",
				u"Those Who Walk in Twilight"},
			{u"秘密の二人",
				u"The Secret Duo"},
			{u"ビッグ・ボンバーズ",
				u"The Big Bombers"},
			{u"プリティーアニマルズ",
				u"The Pretty Animals"},
			{u"鷹原羽依里監視隊",
				u"Takahara Hairi Surveillance Squad"},
			{u"四神天舞",
				u"Dance of the Four Heavenly Beasts"},
			{u"ホワイトレター",
				u"White Letters"},
			{u"鬼脱ぎ",
				u"Stripping Oni"},
			{u"狩人の憂鬱",
				u"Melancholy of the Hunter"},
			{u"鬼おっぱい",
				u"Oni Titties"},
			{u"前大会覇者・獣皇",
				u"Prior Champion and the Divine Beast"},
			{u"濁り無き者",
				u"The Unblemished"}
		};

		const char16_t* PLAYERS_FOR_ATTACK[] = {
			u"Hairi",
			u"Shiroha",
			u"Ao",
			u"Kamome",
			u"Tsumugi",
			u"Umi",
			u"Kyouko",
			u"Ryouichi",
			u"Tenzen",
			u"Miki",
			u"Shizuku",
			u"Genbu",
			u"Shiki",
			u"Tenzen",
			u"Inari",
			u"Ai",
			u"Tsumugi",
			u"Scary Old Man"
		};

		const char16_t* MESSAGES[] = {
			u"Yo!",
			u"Hah!",
			u"Ho!",
			u"That's nothing!",
			u"Sei!",
			u"Try this on for size!",
			u"Hoooh!",
			u"Not done yet!",
			u"Go!",
			u"Don't go falling for me!",
			u"Goooooo!",
			u"Take this!",
			u"Hah, not even close!",
			u"Have it back!",
			u"You're mine!",
			u"Wide open!",
			u"Right back at you!",
			u"Pretty decent power, right?",
			u"Fallen Angel Style - Unsealed Demon-Eye!",
			u"Crap!",
			u"Woah!",
			u"Wait!",
			u"I'm saved!",
			u"Thanks!",
			u"Good going, partner!",
			u"Crap, my racket!",
			u"Gah, talk about crazy power!",
			u"Ow!",
			u"Woah!",
			u"Wait!",
			u"Oof!",
			u"Seriously!?",
			u"That's nothing!",
			u"UWAAAAAAAHHHHHHHH!",
			u"Sorry! I'm back!",
			u"I... can't...",
			u"Use this!",
			u"That's nothing!",
			u"Witness my ping-pong awakening!",
			u"I'm not just pretending to be a city boy!",
			u"TAKAHARAAAAAA! HAIRIIIIIIII!",
			u"Playtime's over!",
			u"When all's said and done... I'm your reaper!",
			u"The power... It's overflowing from within me!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"Hah...! What was I just...?",
			u"Fallen Angel Style - Bookcase of Darkness!",
			u"Fallen Angel Style - Illusory Neighbor!",
			u"Dance, O' Chirrup of the Atramentous Crane!",
			u"Lead, O' Wings of the Magnificent Firebird!",
			u"Galactic Boomerang!",
			u"Hurricane Thunder!",
			u"Host Arts - Luscious Bite!",
			u"Host Arts - Entwined Pinkies!",
			u"Let there be table tennis!",
			u"Worship me...",
			u"Fallen Angel Style - Bandage of Sealing!",
			u"Reach, O' Warble of the White Heron!",
			u"Rolling Jet!",
			u"Host Arts - Kabedon!",
			u"Know your place, Human!",
			u"Fallen Angel Style - Unsealed Demon-Eye!",
			u"Love, O' Union of the Flame Phoenix!",
			u"Winning the Phantom!",
			u"Host Arts - Champagne Tower!",
			u"Genesis of Table Tennis!",
			u"Absolute Summoning - Ultimate Beast Inari!",
			u"Huh? Again? Why...?",
			u"I told you not to bother with me...",
			u"Ei!",
			u"Yaah!",
			u"Take this!",
			u"Hoi!",
			u"Haah...",
			u"Ei!",
			u"Yaaah!",
			u"Take this!",
			u"Hoi!",
			u"Eii!",
			u"Mmh... Hah!",
			u"I don't really like losing.",
			u"I'm still okay!",
			u"I don't really like losing.",
			u"Take this... Hah!",
			u"Naruse's Raging Vortex!",
			u"I can take this much!",
			u"I see right through you!",
			u"Mmmmhhhh... Super Spirit Guuuuuun!",
			u"Ah...",
			u"I messed up...",
			u"Wah!",
			u"Th-Thanks.",
			u"I'll be careful.",
			u"I believed in you.",
			u"Ahh, my racket...",
			u"My hand's all tingly...",
			u"Augh!",
			u"You're awful!",
			u"Kyah!",
			u"Kyah!",
			u"Wah!",
			u"I'm fine!",
			u"KYAAAAHHHHHH!",
			u"I haven't lost yet!",
			u"Ahhh... I regret everything...",
			u"Fine, okay, take this.",
			u"I haven't lost yet!",
			u"Spirits guide me!",
			u"I don't like losing!",
			u"I'm not a loner or anything, really!",
			u"I told you not to bother with me, didn't I...!?",
			u"I told you not to bother with me, didn't I...!?",
			u"I told you not to bother with me, didn't I...!?",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"What was I...?",
			u"Oooh, so you wanna go one on one with me?",
			u"All right, I'll win this for you.",
			u"Ho!",
			u"Heh heh!",
			u"C'mon!",
			u"Ho!",
			u"You're not half bad!",
			u"Wide open!",
			u"Saw right through you!",
			u"There!",
			u"Bring it on!",
			u"Uryaaah!",
			u"You're mine!",
			u"Uryaaah!",
			u"Teaches you to look down on me!",
			u"Uryaaah!",
			u"Secret Technique! Butterfly's Dream!",
			u"C'mon, time to start over!",
			u"C'mon, time to start over!",
			u"Don't let your guard down!",
			u"Here, have it back!",
			u"The Sorakados hold dominion over the past... Fantastical Oblivion!",
			u"Waaaah!",
			u"S-Sorry!",
			u"Mnaah!?",
			u"Thanks!",
			u"Phew, you saved me!",
			u"I'll cover for you next time!",
			u"My racket!",
			u"Peh... I can play bare-handed, too!",
			u"Ouch!",
			u"Hey!",
			u"Kyah!",
			u"Ouch!",
			u"Geh...!",
			u"Easy peasy!",
			u"KYAAAAHHHHH!",
			u"Oh, I'm pissed now! I'm gonna make you squeal!",
			u"Gah... I guess the loser has no right to say no...",
			u"You're unbelievable―here, use this.",
			u"Oh, I'm pissed now! I'm gonna make you squeal!",
			u"Now I'm really worked up!",
			u"As if I'd let you see me lose!",
			u"I'll be gentle!",
			u"Ah... Okay, I'm done with this.",
			u"Ah... Okay, I'm done with this.",
			u"Ah... Okay, I'm done with this.",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"H-Huh? What just...?",
			u"Sounds good. You're on!",
			u"Together, to adventure!",
			u"Ei!",
			u"Yah!",
			u"Taah!",
			u"Yaaay!",
			u"Workin' hard!",
			u"Eiii!",
			u"Tei!",
			u"Heave, ho!",
			u"Eiii!",
			u"Yahoo!",
			u"This'll do it!",
			u"Steady as she goes!",
			u"No problems!",
			u"Steady as she goes!",
			u"Certain Death! Tetro-doki-doki-toxin!",
			u"Get shocked!",
			u"Doin' dandy!",
			u"Plenty more where that came from!",
			u"Catpaw Whiskerneers! Ready! Fiiiiire!",
			u"Huh?",
			u"Crap!",
			u"Eeek!",
			u"Thaaanks!",
			u"Nice assist!",
			u"You can do it, me!",
			u"My rackeeeet!",
			u"W-W-Wait up a second!",
			u"Oooow!",
			u"You're the worst!",
			u"Kyaahn!",
			u"Kyaahn!",
			u"Aaaah!",
			u"Heh heh!",
			u"FUGYAAAAHHHHHH!",
			u"I'm paying you back for that... with interest!",
			u"I guess... the adventure's over...",
			u"Here, it's treasure!",
			u"I'm paying you back for that... with interest!",
			u"The real adventure starts now!",
			u"All ships, open your gunports! ...Just kidding!",
			u"I'll take you with me... to the other side of the net!",
			u"Oh, I'm making you pay for this!",
			u"Oh, I'm making you pay for this!",
			u"Oh, I'm making you pay for this!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"Huuh? What was that about?",
			u"Okay, let's practice together!",
			u"Leave it to me, I'll help you out!",
			u"Your turn!",
			u"Okay!",
			u"That was good!",
			u"Your turn!",
			u"Okay!",
			u"Mugyu!",
			u"Found it!",
			u"I've got it!",
			u"Oh, wow!",
			u"I'm invincible!",
			u"I won't miss a shot!",
			u"I'm invincible!",
			u"Karmic retribution!",
			u"I'm invincible!",
			u"Wenders Seeeeeal!",
			u"Please calm down.",
			u"Have it back!",
			u"Mugyuuto return!",
			u"Wenders Style Secret Arts! Hocus Pocus!",
			u"Mugyu?",
			u"I messed up.",
			u"Aahhh...",
			u"You saved me!",
			u"Thank you very much!",
			u"My partner's invincible!",
			u"Mugyu! My racket!",
			u"If only I had some Paringles...",
			u"Mugyu!",
			u"Pretty good!",
			u"Kyaaa!",
			u"Mugyu!",
			u"Mugyuuu!",
			u"I'm okaaay!",
			u"Mugyuuuuuuuu!",
			u"I'm back!",
			u"Mugyu... I'm not good enough...",
			u"I hope this helps!",
			u"I'm okaaay!",
			u"Let's search together!",
			u"Paaaaaringlllllles!",
			u"Ooooh, I get it!",
			u"Mugigigigi... Mugiiiii!",
			u"Mugigigigi... Mugiiiii!",
			u"Mugigigigi... Mugiiiii!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"Mugyu? Why does my throat hurt?",
			u"I'll take you on!",
			u"I'll spare no effort to win!",
			u"Ei!",
			u"Ho!",
			u"Yaa!",
			u"Naah!",
			u"Heh heh!",
			u"Teyah!",
			u"Your guard's way down!",
			u"Yaaah!",
			u"Your guard's way down!",
			u"No mercy!",
			u"Taaaah!",
			u"I'm not holding back!",
			u"I see right through you!",
			u"It's over!",
			u"Medicinal Fried Rice!",
			u"It turned out great!",
			u"Too easy!",
			u"Eiiiii!",
			u"I choose you, Shimamon!",
			u"Wah!",
			u"Waaaaah!",
			u"!?",
			u"I'm saved!",
			u"Thank you very much!",
			u"I knew you'd help!",
			u"Umyaa! My racket!",
			u"I haven't lost just yet!",
			u"Augh!",
			u"Kyaaah!",
			u"You don't hold back, do you?",
			u"Augh!",
			u"!?",
			u"That won't work on me!",
			u"UMYAAAAAHHHHHHH!",
			u"I'm sorry, I'm fine now!",
			u"I, I can't carry on...",
			u"Try to hold out with this.",
			u"That won't work on me!",
			u"Umi Zoooooooone!",
			u"Fried rice tiiiiime!",
			u"I'm going all-out starting now!",
			u"Fried rice is all about heat!",
			u"Fried rice is all about heat!",
			u"Fried rice is all about heat!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"I feel like I just woke up from a dream.",
			u"You must be bored, huh? Well, okay, I guess.",
			u"I don't feel like losing!",
			u"Heh heh!",
			u"Easy!",
			u"Yah!",
			u"Yah!",
			u"Heh heh!",
			u"How's that!?",
			u"I'm not playing around!",
			u"Take this!",
			u"Ooooh!",
			u"Umyaaaaaah!",
			u"Yaaaaaaah!",
			u"Wide opeeeeen!",
			u"Have it back!",
			u"I'm still just getting started!",
			u"All-purpose fried rice!",
			u"It's tasty, I think!",
			u"Talk about half-baked!",
			u"Bring it on!",
			u"Get 'em, Shimamon!",
			u"Aaahhh!",
			u"You're the worst!",
			u"!?",
			u"I'm saved!",
			u"Thanks!",
			u"Great as always!",
			u"My racket went frying!",
			u"I'm not gonna lose!",
			u"Woooooah!",
			u"Guh...!",
			u"Scum...!",
			u"Guh...!",
			u"!?",
			u"That's not gonna work!",
			u"UMYAAAAAHHHHHHH!",
			u"Sorry! I'm fine now!",
			u"You're not going any further!",
			u"C'mon, take this and pull yourself together!",
			u"That's not gonna work!",
			u"Umi Zoooooooone!",
			u"Muuuuuuuh! I'm gonna beat the stuffing outta you!",
			u"Maximum energy!",
			u"You're not getting away with this!",
			u"You're not getting away with this!",
			u"You're not getting away with this!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"Was I dreaming...?",
			u"Yaaay, let's play!",
			u"Let's work hard together!",
			u"Eh heh heh!",
			u"I hit it back!",
			u"Great, right?",
			u"Doing my best!",
			u"Oooh?",
			u"Eiiii!",
			u"Yaaaah!",
			u"How about this!",
			u"How about this!",
			u"Take this!",
			u"Praise me!",
			u"Here we go!",
			u"Hanmura!",
			u"Heh heh heeeeh!",
			u"Tried-my-best fried rice!",
			u"Is it good? Is it good?",
			u"Umyaaaaaah!",
			u"Have it back!",
			u"Shimamon, help me!",
			u"I messed up!",
			u"Umyah!",
			u"!?",
			u"I'm saved!",
			u"Thank you!",
			u"Woah! You're so good!",
			u"Umyaa... My racket...",
			u"You're a meanie...",
			u"Hyaaaah!",
			u"You're a meanie!",
			u"Uweeeeeh!",
			u"Hyaaaah!",
			u"Umyuuu...",
			u"It doesn't hurt!",
			u"UMYAAAAAHHHHHH!",
			u"I'm back! Doing my best again!",
			u"I caaaan't...",
			u"Use this!",
			u"It doesn't hurt!",
			u"Umi Zoooooooone!",
			u"Here goooes! I'm not going easy!",
			u"Umyaaaaaaaahhhhhhhh!",
			u"No mercyyyy!",
			u"No mercyyyy!",
			u"No mercyyyy!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"A dream...? Myuuu?",
			u"All right, I'll teach you more of the Katou style.",
			u"The Katou style will protect you!",
			u"Well?",
			u"How's this?",
			u"Okay!",
			u"Here you go!",
			u"Heh heh!",
			u"Ei!",
			u"I won't lose!",
			u"Eeeei!",
			u"Ei!",
			u"I won't lose!",
			u"Taaaaake... this!",
			u"Okay, here you go!",
			u"Did you think that would slip through?",
			u"Okay, here you go!",
			u"Katou Style: Mirror Poison!",
			u"This is the curse of the Katous.",
			u"You've got a long way to go.",
			u"Here, have another.",
			u"The Katou style will drown the world in despair.",
			u"Oh, my!",
			u"Hyah!",
			u"Ah... No way!",
			u"That's a big help!",
			u"I'll be sure to thank you later.",
			u"I'd expect no less!",
			u"My my, my racket...",
			u"You do some awful things.",
			u"Hyah!",
			u"How awful...",
			u"Kyaaaah!",
			u"Hyah!",
			u"Oh me, oh my...",
			u"Did you do something?",
			u"KYAAAAAAAAHHHHHHH!",
			u"I might just have to go a bit all-out!",
			u"It looks like this is the end.",
			u"I found this in the shed.",
			u"I might just have to go a bit all-out!",
			u"Allow me to demonstrate the power and dominance of the Katou style!",
			u"I remember... This seething spirit...!",
			u"I won't be able to hold back from here on out!",
			u"That day... I remember it well.",
			u"That day... I remember it well.",
			u"That day... I remember it well.",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"I can't believe I was taken by a curse other than the Katous'...",
			u"I'll take you on, any time, anywhere!",
			u"I haven't been stripping just for show!",
			u"C'mon!",
			u"How's that?",
			u"Take this!",
			u"Not bad!",
			u"Whoop!",
			u"Too easy!",
			u"Not gettin' past me!",
			u"Better strip another layer off!",
			u"Too easy!",
			u"Puuuuuurge!",
			u"You're open right over there!",
			u"This last one's a bit different!",
			u"Your back's wide open!",
			u"This last one's a bit different!",
			u"Secret Technique! Enemy Purge!",
			u"I'll get rid of anyone that gets in my way!",
			u"This passion's not bad!",
			u"Not quite naked enough!",
			u"Heh heh, naked festival! Let's get hyyyyped!",
			u"Woah...!?",
			u"Whahuh?",
			u"Nmaaah!?",
			u"Thanks, dude!",
			u"Thanks!",
			u"I'd totally strip for you!",
			u"Woah! My racket!",
			u"Heh, tryin' to blow my clothes away, too?",
			u"Guwah!",
			u"Gyah!",
			u"Dammit...!",
			u"Kyah!",
			u"Guwah!",
			u"Heh, not gonna work on me!",
			u"You're kiddiiiiiing!",
			u"Heh, 'bout time to strip yet?",
			u"Heh heh―feels like I've been stripped bare...",
			u"No worries, just use this!",
			u"Heh, 'bout time to strip yet?",
			u"Heh! I'll be keeping you company from now on!",
			u"Pupupupupupuuuuuuuurge!",
			u"Waaaaaahhhhhhh! I can't help but striiiiip!",
			u"I'll strip you down, here and now!",
			u"I'll strip you down, here and now!",
			u"I'll strip you down, here and now!",
			u"Ngyah!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"Holy crap, think I passed out for a minute!",
			u"Mmmmmmm, puuuuuuurge!",
			u"Heh... Naturally, no one else could be fit to oppose you.",
			u"I see, that moment of brilliance is etched into your mind, is it not?",
			u"Not bad!",
			u"Good!",
			u"Hmph!",
			u"Good!",
			u"How's this!?",
			u"What's wrong!?",
			u"Come at me harder!",
			u"I want to truly know you!",
			u"Too slow!",
			u"Hah!",
			u"Did you think I'd let that slide!?",
			u"This shot's coming straight from my soul! Take it!",
			u"I've heard you loud and clear!",
			u"This shot's coming straight from my soul! Take it!",
			u"This is my all-out...",
			u"This shot's coming straight from my soul! Take it!",
			u"Hammurabi Cannon: Sky!",
			u"You can do better than that!",
			u"This is my everything!",
			u"Guh...!",
			u"I, I anticipated this!",
			u"What!?",
			u"I knew you'd save that!",
			u"My thanks!",
			u"You're a heaven-sent child of doubles ping-pong!",
			u"Muh! I lost my racket!?",
			u"I still have my ping-pong spirit!",
			u"Gabuh!",
			u"Not done yet!",
			u"Aaah... Yes...!",
			u"Gahah!",
			u"Not bad...",
			u"Is that all you've got?",
			u"This power...! Oooohhhhhhhhhh!",
			u"Heh, let this be my answer to your shot from a moment ago!",
			u"Heh... It was fun...",
			u"Truly, you are worthy!~",
			u"Heh, let this be my answer to your shot from a moment ago!",
			u"Witness the power of one who holds the heavens in his grasp!",
			u"Just try to withstand my pressure!",
			u"Hah, hah, so good, so goooood!",
			u"Hear ye the roar of my soul!",
			u"Hear ye the roar of my soul!",
			u"Hear ye the roar of my soul!",
			u"Eeeeeh!",
			u"Guh, my racket's not doing so well!",
			u"Taaaake this!",
			u"Secret Technique, err... Anyway, Secret Technique!",
			u"Amazing, Mizuori-senpai! That was a great hit!",
			u"Oooh, can't get it? What a shaaaame!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"Kieeeh? What was I...?",
			u"I'm alone.",
			u"Always, alone.",
			u"Secret Technique - Dragon Slave! ",
			u"Yeah, improving through mutual competition's a good way to do things.",
			u"My reflexes are sharper than anyone's!",
			u"Hoh!",
			u"Yah!",
			u"Whoops!",
			u"Sheesh!",
			u"I see...!",
			u"Nyah!",
			u"Just your imagination!",
			u"Take this!",
			u"Nyah!",
			u"All right!",
			u"I won't miss a shot!",
			u"My aim's on-point!",
			u"Don't let your guard down!",
			u"I won't miss a shot!",
			u"Hydro Ping-Pong Mode! Fire!",
			u"I'm not holding back!",
			u"Your spin's pathetic!",
			u"Speed's all you've got!",
			u"Youth Association Executive Nomura Miki, coming through!",
			u"So strong...!",
			u"I... I'm not done yet!",
			u"No way...!?",
			u"Thank you!",
			u"Just relax and leave your back to me!",
			u"Not bad!",
			u"What? My racket...!?",
			u"Th-This isn't fair!",
			u"Guh!",
			u"Nyaaaah!",
			u"Oh, you didn't!",
			u"Nyaaaah!",
			u"Wha!?",
			u"Are you serious?",
			u"KYAAAAAHHHHHH!",
			u"I'm going all-out starting now!",
			u"Guh... I guess I still have a long way to go.",
			u"Leave your back to me!",
			u"I'm going all-out starting now!",
			u"I'll take this island's techniques and apply them to ping-pong!",
			u"Aim, check! Ammunition, check! You're not getting away this time!",
			u"Heh heh, heh heh heh, this is pretty fun, huh?",
			u"...I'm shooting, and I'm not stopping even if you cry.",
			u"...I'm shooting, and I'm not stopping even if you cry.",
			u"...I'm shooting, and I'm not stopping even if you cry.",
			u"No stripping.",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"Muh, looks like I was confused for a moment there...",
			u"うふふ、おっぱいを貸してもらうわね",
			u"安心感……大切なことよね",
			u"Ei!",
			u"Fufufu!",
			u"There!",
			u"Fufu♪",
			u"My♪",
			u"Where are you looking?",
			u"Yaaah!",
			u"Big Bomber!",
			u"Where are you looking?",
			u"Yaaah!",
			u"Smaaaaaash!",
			u"Boooooooooooobs!",
			u"Prepare to be enveloped!",
			u"Boooooooooooobs!",
			u"Bust Buster - Captivating Dance!",
			u"Be good, won't you?",
			u"Boobs repel all!",
			u"Back to you.",
			u"Hypno-boobs! The sky is the limit♪",
			u"Kyah...!",
			u"I-I'm sorry!",
			u"Wait, ah!",
			u"Thank you.",
			u"Like a support bra for a girl in need!",
			u"Amazing!",
			u"Aaahn, my racket!",
			u"How awful of you.",
			u"Kyah!",
			u"Yaaahn!",
			u"Nngh...!",
			u"Yaaahn!",
			u"My♪",
			u"How titillating.",
			u"AAAAAAAAAHHHN!",
			u"Boobs always spring back into shape.",
			u"I tried my best, but wow...",
			u"Boobs are only boobs in a pair.",
			u"Boobs always spring back into shape.",
			u"Boob Zooooooooone!",
			u"I'm sorry, but this is where my kindness ends!",
			u"Fufu, don't worry, I won't bite.",
			u"Whoever so believes shall in them have... eternal boobs!",
			u"Whoever so believes shall in them have... eternal boobs!",
			u"Whoever so believes shall in them have... eternal boobs!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"Fufu, that was a tad immodest of me, wasn't it?",
			u"You're striving to reach greater heights? Very well.",
			u"An excess of power will be the end of you.",
			u"Muh...",
			u"Hmm...",
			u"Hoh...",
			u"Hmm...",
			u"Again.",
			u"Muh!",
			u"Hmm!",
			u"Not good enough!",
			u"More!",
			u"Hmmmm!",
			u"Is that all you've got!?",
			u"Not good enough!",
			u"You impertinent brat!",
			u"Not good enough!",
			u"Genbu Cannon!",
			u"Do you think you can withstand this!?",
			u"No effect!",
			u"This is what a perfect defense looks like!",
			u"Witness the Storm-Dance of the Four Divine Beasts!",
			u"Mmmnh...!",
			u"Nwoah!",
			u"Mnaaah...!",
			u"Hoh, not bad.",
			u"Well hit!",
			u"My thanks.",
			u"Sending my racket flying? Such impudence!",
			u"You think this means you've won!?",
			u"Muh...",
			u"Guwah!",
			u"What!?",
			u"Guwah!",
			u"Wha─!?",
			u"Did something happen?",
			u"Take thiiiiiiis!",
			u"Enough with the games!",
			u"Hmph, so you've transcended me...?",
			u"Believe in your own fists!",
			u"Enough with the games!",
			u"You damn braaaaat!",
			u"I call upon the Four Divine Beasts!",
			u"Nuwaaaahhhhh! My scars, they ache!",
			u"Feel the wrath of Genbu, and tremble!",
			u"Feel the wrath of Genbu, and tremble!",
			u"Feel the wrath of Genbu, and tremble!",
			u"Muh... Muuuh.",
			u"I'm taking this seriously.",
			u"How's this?",
			u"Secret Technique of the Four Divine Beasts!",
			u"A splendid hit, my granddaughter!",
			u"Oooh, you put a really unique spin on that one!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"Guh, to think there's a curse potent enough to capture even me...!",
			u"んへへ、僕が鍛えてやるぜ",
			u"おいおい、鬼の出番かい？",
			u"Let's go!",
			u"Teyah!",
			u"Towah!",
			u"Teyah!",
			u"Towah!",
			u"Eat this!",
			u"Nheheee!",
			u"Yaaah!",
			u"Eat this!",
			u"Nheheee!",
			u"You're wide open!",
			u"You're wide open!",
			u"Didja think I'd let that fly!?",
			u"Didja think I'd let that fly!?",
			u"Miracle Cure - Ethereal Omusubi!",
			u"Omusubi are forever faithful!",
			u"Nhehe! You can have this back!",
			u"You could try a little harder, ya know!",
			u"Kamiyama Style Special Move: Satiated Oni Soul Shot!",
			u"Bweh!",
			u"How could this be!?",
			u"Bweh!",
			u"Ya saved me!",
			u"I will repay this debt!",
			u"Ya have my gratitude!",
			u"Bweh! My racket!",
			u"Woah now, you're crueler than I thought.",
			u"Bweh!",
			u"Oni!",
			u"You brute!",
			u"Bweh!",
			u"Oni!",
			u"Is that all ya got?",
			u"BWEEEEEEEEEEEEHHHH!",
			u"How dare you!? You have some nerve!",
			u"How could I lose...? Unfathomable...!",
			u"Take this as part of myself!",
			u"How dare you! You have some nerve!",
			u"Oooooh! The oni inside me―its power awakens!",
			u"I will hold back no more! I'm gonna make you cry!",
			u"Come on, the party's just starting!",
			u"Behold that which makes an oni!",
			u"Behold that which makes an oni!",
			u"Behold that which makes an oni!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!",
			u"Huh? Where'd my amazingness go?",
			u"Pon!",
			u"Pon!",
			u"Pon!",
			u"Pon!",
			u"Pon!",
			u"Pon!",
			u"Pon!",
			u"Pon!",
			u"Pon!",
			u"Pon!",
			u"Pooooooon!",
			u"Pooooooon!",
			u"Pooooooon!",
			u"Pooooooon!",
			u"Pooooooon!",
			u"Pooooooon!",
			u"Pooooooon!",
			u"Pooooooon!",
			u"Po-po-pooon!",
			u"Pon!?",
			u"Pon!?",
			u"Pon!?",
			u"Pon♪",
			u"Pon♪",
			u"Pon♪",
			u"Pon!?",
			u"Pon!?",
			u"Pooon...",
			u"Pooon...",
			u"Pooon...",
			u"Pooon...",
			u"Pooon...",
			u"Pon!",
			u"Pooooooon!",
			u"Pooon...",
			u"Kyuwan...",
			u"Pon!",
			u"Pon!",
			u"Pooon!",
			u"Pooon!",
			u"Pooon!",
			u"Fuuu!",
			u"Fuuu!",
			u"Fuuu!",
			u"POPOPOOOOOOOOOOON!",
			u"POPOPOOOOOOOOOOON!",
			u"POPOPOOOOOOOOOOON!",
			u"Pon...",
			u"I hope you can go home soon."
		};
	}
}

namespace STRINGS {

	const std::unordered_map<UTF8_lambda> COMMON = {
		//Basic
		{"早送り",
			"Skip"},
		{"既読のみ",
			"Previously Read Only"},
		{"すべて",
			"All"},

		{"選択肢の位置",
			"Position of Choices"},
		{"下",
			"Bottom"},
		{"中央",
			"Center"},

		{"ボイス再生",
			"Voice"},
		{"ページ送りで停止",
			"Stop on New Message"},
		{"　 停止しない 　",
			"No Stops"},
		{"【ボイス再生】「停止しない」にすると、音声再生中にページを送っても音声が流れ続けます。$S027$C[00afc0]（次ページに音声がある場合停止）",
			"Voice: If you select No Stops, sound will continue to play even if you send a message during voice playback.\n$S026$C[00afc0](It stops if there is sound on the next message.)"},

		{"日付表示",
			"Show Date"},
		{"オフ",
			"No"},
		{"オン",
			"Yes"},

		{"振動の強さ",
			"Rumble Feature"},
		{"なし",
			"Off"},
		{"小",
			"Min"},
		{"中",
			"Mid"},
		{"大",
			"Max"},

		{"自動スリープ",
			"Auto-Sleep"},
		{"無効化しない",
			"Do Not Disable"},
		{"無効化する",
			"Disable"},
		{"【自動スリープ】「無効化する」にすると、オートモード・ムービーなどの自動進行\nイベント・MUSIC鑑賞画面（音楽再生中）では、自動スリープに入らなくなります。",
			"Auto-Sleep: Selecting Disable will disable auto-sleep during Auto Mode and cutscenes for things like auto game progression and Music Player (during music playback)."},

		//Button1
		{"Rボタン(早送り)",
			"R Button(Skip)"},
		{"押している間",
			"While Pressed"},
		{"開始／解除",
			"Start/Stop"},

		{"Lボタン(早戻し)",
			"L Button(Rewind)"},

		{"ZRボタン(早送り)",
			"ZR Button (Skip)"},
		{"　なし　",
			"Disable"},

		{"ZLボタン(早戻し)",
			"ZL Button (Rewind)"},

		{"－ボタン",
			"− Button"},
		{"　クイックロード　",
			"Quick Load"},
		{"　オートモード　",
			"Auto Mode"},

		{"カーソル移動",
			"Cursor Control"},
		{"方向ボタンのみ",
			" D-Pad "},
		{"Lスティック＋方向ボタン",
			"Left Stick + D-Pad"},

		//Button2
		{"Joy-Conを本体から取り外した時の設定をします。",
			"Adjust the settings for when you detach the Joy-Con from the console."},

		{"ZRボタン",
			"ZR Button"},
		{"早戻し",
			"Rewind"},
		{"【ZRボタン】早戻しの設定は「ボタン1」の「Lボタン(早戻し)」と同じになります。\n$C[00afc0]現在の設定は「押している間」です。",
			"ZR Button: Rewind will be set to be the same as the L Button for Button1.\n$C[00afc0]The current setting is (While Pressed)."},
		{"【ZRボタン】早送りの設定は「ボタン1」の「ZRボタン(早送り)」と同じになります。\n$C[00afc0]現在の設定は「なし」です。",
			"ZR Button: Skip will be set to be the same as the ZR Button for Button1.\n$C[00afc0]The current setting is (Disable)."},
		{"【ZRボタン】早送りの設定は「ボタン1」の「ZRボタン(早送り)」と同じになります。\n$C[00afc0]現在の設定は「押している間」です",
			"ZR Button: Skip will be set to be the same as the ZR Button for Button1.\n$C[00afc0]The current setting is (While Pressed)."},
		{"【ZRボタン】早送りの設定は「ボタン1」の「ZRボタン(早送り)」と同じになります。\n$C[00afc0]現在の設定は「開始／解除」です。",
			"ZR Button: Skip will be set to be the same as the ZR Button for Button1.\n$C[00afc0]The current setting is (Start/Stop)."},
		{"【ZRボタン】早戻しの設定は「ボタン1」の「Lボタン(早戻し)」と同じになります。\n$C[00afc0]現在の設定は「開始／解除」です。",
			"ZR Button: Rewind will be set to be the same as the L Button for Button1.\n$C[00afc0]The current setting is (Start/Stop)."},

		{"Ａボタン",
			"Hold the A"},
		{"長押しでオートモード",
			"for Auto Mode"},
		{"1秒",
			"1 sec"},
		{"1.5秒",
			"1.5 sec"},
		{"2秒",
			"2 sec"},
		{"2.5秒",
			"2.5 sec"},
		{"3秒",
			"3 sec"},

		{"Rスティック 右方向",
			"Right Stick (Tilt →)"},
		{"ジャンプ(送り)",
			"Jump (Forward)"},
		{"１つ送り",
			"Forward Once"},

		{"Rスティック 左方向",
			"Right Stick (Tilt ←)"},
		{"ジャンプ(戻し)",
			"Jump (Backward)"},
		{"１つ戻し",
			"Rewind Once"},

		{"振動するJoy-Con",
			"Joy-Con Rumble"},
		{"Joy﹣Con(L)",
			"Joy﹣Con (L)"},
		{"Joy﹣Con(R)",
			"Joy﹣Con (R)"},
		{"　両方　",
			"Both"},

		//Touch
		{"ジャンプ（送り）",
			"Jump (Forward)"},
		{"ジャンプ（戻し）",
			"Jump (Backward)"},
		{"メッセージウィンドウ内でドラッグすると早送り。\nフリックすると自動早送り（タップで解除）。",
			"Drag in the message window to Skip.\nAuto skip by swiping (stop by tapping)."},
		{"メッセージウィンドウ内でドラッグすると早戻し。\nフリックすると自動早戻し（タップで解除）。",
			"Drag in the message window to Rewind.\nAuto rewind by swiping (stop by tapping)."},
		{"メッセージウィンドウ外でフリックすると「次の選択肢／チャプター」もしくは「既読部分の最後」までジャンプ。",
			"Swipe outside the message window jumps to next choice/chapter, or the end of previously read text."},
		{"メッセージウィンドウ外でフリックすると「直前の選択肢／チャプター」までジャンプ。",
			"Swipe outside the message window to jump to previous choice/chapter."},
		{"メッセージウィンドウ外でフリックすると「次のチャプター」もしくは「既読部分の最後」までジャンプ。",
			"Swipe outside the message window to jump to the start of the next chapter or the end of previously read text."},
		{"メッセージウィンドウ外でフリックすると「直前のチャプター」までジャンプ。",
			"Swipe outside the message window to jump to the previous chapter."},
		{"メッセージウィンドウ外でフリックすると「次の選択肢」もしくは「既読部分の最後」までジャンプ。",
			"Swipe outside the message window to jump to the start of the next choice or to the latest previously read message."},
		{"メッセージウィンドウ外でフリックすると「直前の選択肢」までジャンプ。",
			"Swipe outside the message window to jump to the previous choice."},

		//Text
		{"フォント",
			"Font"},
		{" ゴシック ",
			"Gothic1"},
		{" 丸ゴシック ",
			"Gothic2"},
		{" 太丸ゴシック ",
			"Gothic3"},
		{" 明朝 ",
			"Mincho"},
		{" モダン ",
			"Modern"},

		{"ウィンドウ透明度",
			"Window Opacity"},
		{"不透明",
			"Max"},
		{"透明",
			"Min"},

		{"既読の色表示",
			"Color Read Text"},
		{"　オフ　",
			" Off "},
		{"選択肢のみオン",
			"Only Choices"},
		{"　オン　",
			"On"},

		{"既読色",
			"Color"},
		{"黄",
			"Yellow"},
		{"緑",
			"Green"},
		{"青",
			"Blue"},
		{"紫",
			"Purple"},
		{"赤",
			"Red"},

		{"テキストプレビュー。",
			"Text preview."},
		{"文字表示速度などの設定が反映されます。",
			"Settings such as text speed are reflected."},

		{"文字表示速度",
			"Text Speed"},
		{"遅い",
			"Slow"},
		{"速い",
			"Fast"},

		{"ウィンドウ色",
			"Window Color"},
		{"水色",
			"Light Blue"},
		{"紺",
			"Dark Blue"},
		{"黒",
			"Black"},

		//Auto Mode
		{"文字数待機時間",
			"Wait time/Character"},
		{"0秒/文字",
			"0 sec/char"},
		{"0.2秒/文字",
			"0.2 sec/char"},
		{"【文字数待機時間】オートモードの時、全メッセージが表示されてから、次のメッセージに進むまでの待ち時間を、メッセージの文字数に合わせて設定できます。",
			"Wait Time Per Character: In Auto Mode, this sets the wait time until the next message is displayed based on the number of characters in text."},

		{"固定待機時間",
			"Base Wait Time"},
		{"0秒",
			"0 sec"},
		{"【固定待機時間】「文字数待機時間」に追加する固定的な待ち時間を設定できます。",
			"Base Wait Time: You can set a Base Wait Time to add to\n❝Wait Time Per Character❞."},

		//Sound
		{"マスター音量",
			"Master Volume"},
		{"ボイス",
			"Voice"},
		{"効果音",
			"SFX"},
		{"システム音",
			"System Sounds"},

		//Color
		{"本体タッチスクリーンの色合いを調整します。",
			"You can adjust the color tone of the touch screen on the console."},

		{"色合い調整",
			"Color Adjustment"},
		{"カスタム",
			"Custom"},

		{"彩度",
			"Saturation"},
		{"【彩度】大きくすると色鮮やかになります。",
			"Saturation: Increases or decreases vividness."},

		{"コントラスト",
			"Contrast"},
		{"【コントラスト】大きくすると明暗がはっきりします。",
			"Contrast: Increases or decreases contrast."},

		{"赤レベル",
			"Red level"},
		{"【赤レベル】大きくすると赤みが、小さくすると水色感が増します。",
			"Red Level: Adjusts the visibility of red color."},

		{"緑レベル",
			"Green level"},
		{"【緑レベル】大きくすると緑色感が、小さくするとピンク色感が増します。",
			"Green Level: Adjusts the visibility of green color."},

		{"青レベル",
			"Blue level"},
		{"【青レベル】大きくすると青みが、小さくすると黄色みが増します。",
			"Blue Level: Adjusts the visibility of blue color."},

		{"TVモードでは使用しません。",
			"This function is not available in TV mode."},

		//Names
		{"鳴瀬 しろは",
			"Shiroha Naruse"},
		{"空門 蒼　　",
			"Ao Sarokado"},
		{"久島 鴎　　",
			"Kamome Kushima"},
		{"紬 ヴェンダース",
			"Tsumugi Wenders"},
		{"野村 美希　",
			"Miki Nomura"},
		{"水織 静久　",
			"Shizuku Mizori"},
		{"鷹原 羽未　",
			"Umi Takahara"},
		{"三谷 良一　",
			"Ryouichi Mitani"},
		{"加納 天善　",
			"Tenzen Kanou"},
		{"加藤 うみ　",
			"Umi Katou"},
		{"神山 識　　",
			"Shiki Kamiyama"},
		{"岬 鏡子　　",
			"Kyouko Misaki"},
		{"イナリ　　 ",
			"Inari"},
		{"七海　　　 ",
			"Nanami"},
		{"鷹原 羽依里",
			"Hairi Takahara"},
		{"その他・女 ",
			"Misc(Female)"},
		{"その他・男 ",
			"Misc(Male)"},
		{"鳴瀬 小鳩　",
			"Kobato Naruse"},
		{"空門 藍　　",
			"Ai Sorakado"},

		//Rest
		{"はい",
			"Yes"},
		{"いいえ",
			"No"},
		{"クリア情報（システムデータ）をセーブしました。",
			"Clear data (system data) was saved."},
		{"クイックセーブデータがありません。",
			"Quick save data does not exist."},
		{"クイックセーブは使用できません。",
			"Quick save cannot be used."},
		{"クイックロードは使用できません。",
			"Quick load cannot be used."},
		{"選択したメッセージにジャンプしますか？",
			"Would you like to jump to the selected message?"},
		{"$A1クイックセーブ中です。$S001 \n\n$S024セーブ中は本体の電源を切らないで下さい。",
			"$A1Quick data save in progress... \n$S024$A1Do not turn the console off while saving."},
		{"ロードしますか？",
			"Do you wish to load this save?"},
		{"セーブデータが破損しているため、ロードできません。",
			"The saved data is corrupted and cannot be loaded."},
		{"読み込みエラーが発生しました。\nファイルが壊れている可能性があります。",
			"A reading error occurred.\nThe file may be corrupted."},
		{"セーブしますか？",
			"Do you wish to save?"},
		{"上書きしますか？",
			"Are you sure you wish to overwrite data?"},
		{"$A1セーブ中です。\n$S001 \n$S024$A1セーブ中は本体の電源を切らないで下さい。",
			"$A1Data save in progress...\n$S001 \n$S024$A1Do not turn the console off while saving."},
		{"$A1システムデータをセーブ中です。\n$S001 \n$S024$A1セーブ中は本体の電源を切らないで下さい。",
			"$A1System data save in progress...\n$S001 \n$S024$A1Do not turn the console off while saving."},
		{"$A1クリア情報（システムデータ）をセーブ中です。\n$S001 \n$S024$A1セーブ中は本体の電源を切らないで下さい。",
			"$A1Clear data (system data) save in progress...\n$S001 \n$S024$A1Do not turn the console off while saving."},
		{"セーブが完了しました。",
			"Save completed."},
		{"削除しますか？",
			"Are you sure you wish to delete this save data?"},
		{"削除できません。",
			"This cannot be deleted."},
		{"メニューへ戻りますか？",
			"Return to the menu?"},
		{"タイトル画面へ戻りますか？",
			"Return to the title screen?"},
		{"このページを初期設定に戻しますか？",
			"Would you like to restore this page to the default settings?"},
		{"フォント切り替え中...",
			"Switching fonts..."},
		{"次の選択肢へジャンプしますか？",
			"Do you wish to jump to the next choice?"},
		{"次のチャプターへジャンプしますか？",
			"Do you wish to jump to the next chapter?"},
		{"次の選択肢またはチャプターまでジャンプしますか？",
			"Do you wish to jump to the next choice or chapter?"},
		{"次の選択肢へジャンプ...",
			"Jumping to the next choice ..."},
		{"$A1未読のテキストがあるため、$dその位置でジャンプを停止しました。",
			"Stopped here because of unread text."},
		{"1つ前の選択肢にジャンプしますか？",
			"Do you wish to jump to the previous choice?"},
		{"このチャプターの先頭にジャンプしますか？",
			"Do you wish to jump to the beginning of this chapter?"},
		{"1つ前のチャプターにジャンプしますか？",
			"Do you wish to jump to the previous chapter?"},
		{"閉じる",
			"Close"},
		{"戻る",
			"Back"},
		{"リンクに進む",
			"Go to link"},
		{"戻る ",
			"Back"},
		{" 削除 ",
			"Delete"},
		{"最新へ",
			"Latest"},
		{"初期設定に戻す",
			"Defaults"},
		{"サンプルボイス再生",
			"Sample Voice"},
		{"基本操作説明",
			"Controls"},
		{"ボイス再生",
			"Play Voice"},
		{"ジャンプ",
			"Jump"},
		{"BGM変更",
			"Select Music"},
		{"$A1用語がありません。",
			"There are no keywords."},
		{"閉じる",
			"Next"},
		{"次へ",
			"Next"},
		{"　クイックロード　",
			"Quick Load"},
		{"クイックロード",
			"Quick Load"},
		{"ゲーム開始",
			"Jump to"},
		{"選択したメッセージからゲームを開始しますか？",
			"Do you wish to jump back to this message?"},
		{"進む",
			"Continue"},
		{"ギブアップしますか？",
			"Do you want to give up?"},
		/*Spaces are not a technical issue, just game doesn't allow them for some reason. 
		It's possible to put names with spaces without issues in TextFormatSP_hook,
		but didn't do that to not confuse players.*/
		{"$A1使用できない文字が含まれています。\n$S008\n$S030$C[e02020]デッキ名にはひらがな、カタカナ、漢字、英数字が使用可能です。",
			"$A1Deck name contains invalid characters.\n$S008\n$A1$S030$C[e02020]Hiragana, katakana, kanji, and alphanumeric characters\n$A1$S030$C[e02020]can be used for deck names. No spaces allowed."}
	};

	const std::unordered_map<UTF16_lambda> LOG2 = {
		{u"卓球ミニゲームをプレイしますか？",
			u"Do you want to play the table tennis minigame?"},
		{u"マップ選択",
			u"Map Select"},
		{u"プロローグをスキップしますか？",
			u"Skip the prologue?"},
		{u"駄菓子買い物リスト",
			u"Candy Shopping List"},
		{u"うみになんと呼ばれたいですか？",
			u"What would you like Umi to call you?"},
		{u"エサ設置中",
			u"Setting up Shimamon Bait"},
		{u"島モン対戦相手選択",
			u"Shimamon Fight Opponent Selection"},
		{u"島ポン対戦相手選択",
			u"Shimapong Fight Opponent Selection"},
		{u"パートナー選択",
			u"Doubles Partner Selection"},
		{u"フリーマッチ選択",
			u"Free Match Selection"}
	};

	std::unordered_map<UTF16_lambda> TennisTablePopup = {
		{u"天善は天善ゾーンを展開した！",
			u"Tenzen has entered the Tenzen Zone!"},
		{u"きええええええええええぇぇぇぇぇぇぇーーーーーーー！",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!"},
		{u"羽依里は云った「卓球創造」",
			u"And Hairi said, \"Genesis of Table Tennis.\""},
		{u"羽依里は云った「崇めよ…」",
			u"And Hairi said, \"Worship me...\""},
		{u"羽依里は云った「人よ己を知れ」",
			u"And Hairi said, \"Know your place, Human!\""},
		{u"羽依里が「堕天流・妖睛解放」を放つ！",
			u"$S032Hairi used \"Fallen Angel Style - Unsealed Demon-Eye\"!$S"},
		{u"羽依里が「堕天流・幻想隣人」を放つ！",
			u"$S030Hairi used \"Fallen Angel Style - Illusory Neighbor\"!$S"},
		{u"羽依里が「堕天流・封印包帯」を放つ！",
			u"$S031Hairi used \"Fallen Angel Style - Bandage of Sealing\"!$S"},
		{u"羽依里は云った「卓球あれ」",
			u"And Hairi said, \"Let there be table tennis.\""},
		{u"羽依里が謡う「導け…、大鵬の翼よ」",
			u"$S031Hairi sang \"Lead, O' Wings of the Magnificent Firebird\"!$S"},
		{u"羽依里が謡う「届け…、白鷺の囀り」",
			u"Hairi sang \"Reach, O' Warble of the White Heron\"!"},
		{u"羽依里が謡う「愛よ…、鳳凰と共に」",
			u"Hairi sang \"Love, O' Union of the Flame Phoenix\"!"},
		{u"羽依里が「堕天流・暗黒書架」を放つ！",
			u"$S031Hairi used \"Fallen Angel Style - Bookcase of Darkness\"!$S"},
		{u"羽依里が「ハリケーンサンダー」を繰り出す！",
			u"Hairi struck with \"Hurricane Thunder\"!"},
		{u"羽依里が「ローリングジェット」を繰り出す！",
			u"Hairi struck with \"Rolling Jet\"!"},
		{u"羽依里が「ウィニング・ザ・ファントム」を繰り出す！",
			u"Hairi struck with \"Winning, the Phantom\"!"},
		{u"羽依里が謡う「舞え…、黎鶴の囀り」",
			u"$S030Hairi sang \"Dance, O' Chirrup of the Atramentous Crane\"!$S"},
		{u"羽依里が「ホスト妙技・小指絡め」で誘う！",
			u"Hairi flirted with \"Host Arts - Entwined Pinkies\"!"},
		{u"羽依里が「ホスト妙技・壁打挟撃」で誘う！",
			u"Hairi flirted with \"Host Arts - Kabedon\"!"},
		{u"羽依里が「ホスト妙技・三変酒塔」で誘う！",
			u"Hairi flirted with \"Host Arts - Champagne Tower\"!"},
		{u"羽依里が「ギャラクティカブーメラン」を繰り出す！",
			u"Hairi struck with \"Galactic Boomerang\"!"},
		{u"羽依里スペシャル",
			u"Hairi Special"},
		{u"羽依里が「ホスト妙技・甘噛み」で誘う！",
			u"Hairi flirted with \"Host Arts - Luscious Bite\"!"},
		{u"天善は羽依里のショットに共鳴している！",
			u"Tenzen is resonating with Hairi's shot!"},
		{u"天善は共鳴の効果でテンションが下がりにくくなった！",
			u"$S031Tenzen's tension gauge stabilizes from the resonance!$S"},
		{u"天善は「ハンムラビ砲・天」で応戦してきた！",
			u"$S030Tenzen returned the shot using \"Hammurabi Cannon: Sky\"!$S"},
		{u"天善はショットに込められた熱意を全身で感じてる！",
			u"Tenzen was set aflame by your passionate shot!"},
		{u"天善をＫＯした！",
			u"Tenzen has been KO'ed!"},
		{u"天善が不屈の魂で復帰している！",
			u"Tenzen has reignited the eternal flame of his soul!"},
		{u"天善を場外に吹っ飛ばした！",
			u"Tenzen has been blown off court!"},
		{u"呪われた称号の効果が発動！　天善は呪われた！",
			u"Hairi's 'Cursed' title activates!　Tenzen was cursed!"},
		{u"天善は呪いの効果でショット速度が低下している！",
			u"Tenzen's shots have been slowed by the curse!"},
		{u"天善は羽依里のショットに魅了された！",
			u"Tenzen has been charmed by Hairi's shot!"},
		{u"天善は魅了の効果でテンションが上がりやすくなった！",
			u"$S031Tenzen's tension gauge rises faster thanks to the charm!$S"},
		{u"天善は羽依里のショットに期待している！",
			u"Tenzen is eagerly awaiting Hairi's next shot!"},
		{u"期待の効果でダメージ時にボーナススコアが追加される！",
			u"Bonus damage against the anticipating Tenzen!"},
		{u"天善は羽依里のショットに影響されている！",
			u"Tenzen was profoundly affected by Hairi's shot!"},
		{u"天善は影響の効果で吹っ飛びやすくなった！",
			u"Tenzen is so moved, he's now easily blown away!"},
		{u"天善は羽依里のショットを崇拝している！",
			u"Tenzen is worshiping Hairi's shots!"},
		{u"天善は不屈の魂でコートに立つようになった！",
			u"Tenzen reentered the court riding the flame of his soul!"},
		{u"羽依里が絶招・威鳴狸を放った！",
			u"Hairi used \"Ultimate Technique: Roar of the Tanuki\"!"},
		{u"瞬界の効果が切れた！　時の流れが早くなる！",
			u"$S027The Everlasting Moment has ended! The flow of time has sped back up!$S"},
		{u"羽依里の瞬界が発動した！　世界がコマ送りになる！",
			u"Hairi has entered the Everlasting Moment!"}
	};

	std::unordered_map<UTF16_lambda> TenzenTableSummary = {
		{u"ふっ……お前には驚かされてばかりだ",
			u"Heh... You're just full of surprises."},
		{u"きええええええええええぇぇぇぇぇぇぇーーーーーーー！",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!"},
		{u"俺は新しい言語を知った。人は卓球で繋がることができる",
			u"$S028I've come up with a new saying. 'Hearts are connected by table tennis.'$S"},
		{u"悪くない……、ああ、悪くなかったぞ",
			u"Not bad... No, not bad at all..."},
		{u"良ければ、親友から始めてくれないか",
			u"Could we start over as best friends, if you don't mind?"},
		{u"可能性は感じるが、まだ壁を越えられていないようだな",
			u"$S026I feel your potential, but it seems like you still haven't broken through to it.$S"},
		{u"お前となら狙えるかもな、世界を",
			u"Together, we could take on the world!"},
		{u"た……卓球神……様っ！",
			u"P... Ping-Pong God... sama!"},
		{u"まだまだだな",
			u"You still have a long way to go."},
		{u"寂しいものだな、楽しい時間が終わるというのは",
			u"Tragic, isn't it? That all fun things must come to an end."},
		{u"お前……もしかして伝説の卓球王なのか？",
			u"Could you possibly be... the legendary king of ping-pong...?"},
		{u"修行が足りん。出直してくるんだな",
			u"$S028You haven't had nearly enough practice. Come back when you get better.$S"},
		{u"おまえにはがっかりだ",
			u"I'm disappointed in you."},
		{u"……帰れ",
			u"...Go home."}
	};

	std::unordered_map<UTF16_lambda> TenzenTableMatch = {
		{u"遅い！",
			u"Too slow!"},
		{u"足が止まっているぞ！",
			u"You're tripping up!"},
		{u"なかなか上手いじゃないか",
			u"You're not half bad!"},
		{u"よく返したな",
			u"Well returned."},
		{u"まだまだいくぞ",
			u"I've got more where that came from!"},
		{u"いいぞ、その調子だ！",
			u"That's right, just like that!"},
		{u"ナイスショット！",
			u"Nice shot!"},
		{u"いい音させるじゃないか！",
			u"That shot made an excellent 'ping'!"},
		{u"やるじゃないか！",
			u"Not bad!"},
		{u"素晴らしいぞ！",
			u"Wonderful!"},
		{u"エクセレントだ！",
			u"Excellent!"},
		{u"ひゃっほー！　テンション上がってきたぜぇ！！",
			u"Yahooo! Here we goooo!!"},
		{u"天善天善天善天善天善てんぜーん！",
			u"Tenzen Tenzen Tenzen Tenzen Tenzen Tenzeeeen!"},
		{u"俺の右腕が、お前を倒せとうなっているぅぅぅ！",
			u"My right arm is roaring for your defeat!!"},
		{u"ちょれえええええええええええええええええい！",
			u"Choreeeeeeeeeeeeeeeeeeeiiiiiiii!!"},
		{u"お前ならこのショットを受け止められると信じているぞ！",
			u"I have full confidence you'll be able to stop this shot!"},
		{u"これが、俺の本気だ……",
			u"This is my true power..."},
		{u"我が魂の一撃を受けてみろ！",
			u"This shot's coming from my soul―just try to hit it!"},
		{u"奥義　ドラゴンスレイブ",
			u"Secret Technique - Dragon Slave!"},
		{u"奥義　魂伝影念獅坐威砲",
			u"Secret Technique - Legendary Shadow Soul Majestic Leo Cannon of Desire!"},
		{u"奥義　舞卦処撥斗",
			u"Secret Technique - Dancing Strike of Divine Denial!"},
		{u"奥義　六波羅反台",
			u"Secret Technique - Six Virtues of Enlightenment!"},
		{u"ふっ…この威力、申し分ない",
			u"Heh... This power... Perfect..."},
		{u"ぬああああぁぁぁ！！",
			u"Nuuuuuaaaaaaaaghhh!!"},
		{u"俺を吹っ飛ばすとはな…\nだが、卓球にノックアウトはないぜ！！",
			u"$S024You've done well to blow me away... However,$dthere's no such thing as a knockout in table$dtennis!!$S"},
		{u"見切ったぞ！！",
			u"I've seen right through you!"},
		{u"奥義　ハンムラビ砲・天！",
			u"Secret Technique - Hammurabi Cannon: Sky!"},
		{u"この俺が負けるだと…！",
			u"I lost!? How...!?"},
		{u"これならどうだ",
			u"How about this!?"},
		{u"ふっ！",
			u"Hup!"},
		{u"はっ！",
			u"Hah!"},
		{u"どうだ",
			u"How's that!?"},
		{u"さあっ！",
			u"Nooowww!"},
		{u"かあっ！",
			u"Kaaaaahh!!"},
		{u"てんぜーーん！",
			u"Tenzeeeeeeenn!!"},
		{u"つぁ！",
			u"Hyah!"},
		{u"どうした！",
			u"What's wrong!?"},
		{u"天善ゾーーーン！！",
			u"Tenzen Zoooooone!!"},
		{u"秘奥義！　天全！！",
			u"Extra Secret Technique - Tenzen Omnipotent!"},
		{u"これが愛か……",
			u"So this is love...?"},
		{u"悪くない……",
			u"Not bad..."},
		{u"ときめく……",
			u"My heart, it flutters..."},
		{u"あぁ……",
			u"Ahh..."},
		{u"ぐうううぉぉぉぉっ！",
			u"Guuuuuooooooooh!"},
		{u"こ、このプレッシャーはぁぁ！　たまらん！！",
			u"T-This pressure is... irresistible!"},
		{u"まだまだぁ！　もっと激しいのをぶつけてみろ！",
			u"I'm not done yet! I've got even hotter things up my sleeve!"},
		{u"はぁはぁ、もっと……もっとだあぁぁ！",
			u"Hah, hah... More... Moreeeeee!"},
		{u"き……きもちいぃ……なんだ、この感覚は……",
			u"Ahh... What is this feeling...? It feels so good..."},
		{u"魂伝影念獅坐威砲",
			u"Legendary Shadow Soul Majestic Leo Cannon of Desire!"},
		{u"舞卦処撥斗",
			u"Dancing Strike of Divine Denial!"},
		{u"六波羅反台",
			u"Rokuhara Tandai!"},
		{u"ハンムラビ砲・天！",
			u"Hammurabi Cannon: Sky!"},
		{u"何っ……！　バックスピンが強すぎて……！",
			u"What...!? The backspin was too strong...!?"},
		{u"ぐはあああっ！！",
			u"Guuaaaaaahhhh!"},
		{u"まさか自分に返ってくるとは……",
			u"To think it'd come flying back at me..."},
		{u"諸刃の剣といったところか、おもしろい",
			u"A double-edged sword, huh? Interesting."},
		{u"そうか……お前が、お前こそが卓球か……",
			u"I see... You play... No, you ARE table tennis...?"},
		{u"さあ来い！",
			u"Come on!"},
		{u"む……そうか……",
			u"Hmm..."},
		{u"残念だ…非常に残念だ",
			u"What a shame... What a horrible, horrible shame..."},
		{u"きええええええええええぇぇぇぇぇぇぇーーーーーーー！",
			u"KIIIIEEEEEEEEEEEEEEHHHHHHHHHHHHHHHHH!"},
		{u"どうした？　お前の実力はそんなものか？",
			u"What's wrong? Is that all you've got?"}
	};

	std::unordered_map<UTF16_lambda> ITEMS_POPUP = {
		{u"Sugar Water",
			u"Obtained \"Sugar Water\"!"},
		{u"Melon Rind",
			u"Obtained \"Melon Rind\"!"},
		{u"Earthworm",
			u"Obtained \"Earthworm\"!"},
		{u"Popsicle Stick",
			u"Obtained \"Popsicle Stick\"!"},
		{u"Insect Jelly",
			u"Obtained \"Insect Jelly\"!"},
		{u"Shaved Ice Syrup",
			u"Obtained \"Shaved Ice Syrup\"!"},
		{u"Eggplant",
			u"Obtained \"Eggplant\"!"},
		{u"Spoon Worm",
			u"Obtained \"Spoon Worm\"!"},
		{u"Bonito Flakes",
			u"Obtained \"Bonito Flakes\"!"},
		{u"Torishiro Honey",
			u"Obtained \"Torishiro Honey\"!"},
		{u"Lewd Magazine",
			u"Obtained \"Lewd Magazine\"!"},
		{u"Failed Fried Rice",
			u"Obtained \"Failed Fried Rice\"!"},
		{u"Sea Wookie",
			u"Obtained \"Sea Wookie\"!"},
		{u"Rice Syrup",
			u"Obtained \"Rice Syrup\"!"},
		{u"Fish Sausage",
			u"Obtained \"Fish Sausage\"!"},
		{u"Lewd Magazine R",
			u"Obtained \"Lewd Magazine R\"!"},
		{u"Ultimate Fried Rice",
			u"Obtained \"Ultimate Fried Rice\"!"},
		{u"Lewd Magazine EX",
			u"Obtained \"Lewd Magazine EX\"!"},
		{u"Legendary Shochu",
			u"Obtained \"Legendary Shochu\"!"},
		{u"Umi's Panties",
			u"Obtained \"Umi's Panties\"!"}
	};

	std::unordered_map<UTF16_lambda> LOG_EF1 = {
		{u"ずっと昔",
			u"Long ago..."},
		{u"小さな頃",
			u"When I was little..."},
		{u"永遠みたいな夏を、駆け回っていた",
			u"I ran all around, in a summer that felt like it would never end."},
		{u"家族と",
			u"With family..."},
		{u"友達と",
			u"With friends..."},
		{u"どんなに遊んでもやることは尽きなくて",
			u"No matter how much we played, we never ran out of things to do."},
		{u"太陽はそんな毎日を、まぶしく照らし続けてくれた",
			u"Every single one of those days, the sun washed us in brilliance."},
		{u"いつの間にか、そんな思い出は記憶の彼方へ",
			u"Somewhere along the line, those memories drifted away from me..."},
		{u"ただ、あの日、まぶたに感じたまぶしさだけは、覚えている",
			u"But I still remember the feeling of that brilliance upon my eyelids."},
		{u"あのまぶしさを探して、僕は飛んでいた",
			u"I took flight in search of it."},
		{u"小さな羽で、大きな海をわたろうとしていた",
			u"I set off to cross a vast ocean, carried along by a pair of little wings."},
		{u"かなたに、小さな影が見えた",
			u"Far in the distance, I saw a shadow."},
		{u"海のうえに、ぼんやりと浮かぶ影",
			u"A small, solitary shadow, floating leisurely upon the sea."},
		{u"あぁ",
			u"And I knew..."},
		{u"目指した場所は、もう少し",
			u"The place I'd yearned for was just a little further ahead."},
		{u"もう少しで、たどりつける",
			u"Just a little further, and I would finally arrive..."},
		{u"あの夏に",
			u"I'd finally reach that summer."}
	};

	std::unordered_map<UTF16_lambda> LOG_EF6 = {
		{u"太陽は水平線の向こうに沈みはじめている",
			u"The sun began to sink beyond the horizon."},
		{u"広い草原には、僕と影法師さん、２つの影だけが、長くのびていた",
			u"Our two shadows stretched across the grassy field."},
		{u"ねぇ、今度はあっちにいこう",
			u"Hey, let's go over there this time!"},
		{u"ねぇ",
			u"Hey!"},
		{u"手をひこうとするけど、影法師さんはそこから動かない",
			u"I pulled on its hand, but the shadowy figure didn't move."},
		{u"そのとき、僕はきづいた",
			u"That's when I realized."},
		{u"影法師さんの姿はうっすらと消えかけている",
			u"It was fading away."},
		{u"あたりが暗くなるにしたがって、影法師さんが、見えづらくなっていってい",
			u"As the world grew darker, the shadowy figure was gradually vanishing."},
		{u"影法師さんも帰っちゃうの？",
			u"You're going home, Shadow-san?"},
		{u"そんなのやだ",
			u"No, don't go!"},
		{u"一緒にいよう",
			u"Let's stay together!"},
		{u"影法師さんが何かを言いかける",
			u"The shadowy figure tried to say something."},
		{u"そのとき、ふっと、辺りが暗くなる",
			u"But before it could, the world fell into darkness."},
		{u"水平線の向こうに、太陽が隠れてしまった",
			u"The sun had vanished beyond the horizon."},
		{u"かすかな光だけが残る薄い闇の中で、僕は叫ぶ",
			u"As the light faded away, I shouted."},
		{u"待って──",
			u"Wait!"},
		{u"あなたは誰なんですか！",
			u"Who are you!?"},
		{u"行かないで！",
			u"Don't go!"},
		{u"ねぇ！",
			u"Hey!"},
		{u"ぼんやりと見えていた影法師さんの姿は、完全に、夜の中に消えてしまった",
			u"But the shadowy figure disappeared in the night."}
	};

	std::unordered_map<UTF16_lambda> LOG_EF7 = {
		{u"夜がやってきた",
			u"Night fell."},
		{u"真っ暗な中を、風が通り過ぎていく",
			u"A wind blew through the pitch-black darkness."},
		{u"草木がさざ波立つ音だけが聞こえる",
			u"I could hear nothing more than the rustling of the grass."},
		{u"まるで、海のまっただ中にいるみたいだ",
			u"I felt like I was in the depths of the sea."},
		{u"唯一の灯りは、はるか頭上で輝くお月様だけ",
			u"The only source of light was the moon, far, far above me."},
		{u"手を伸ばしてみる",
			u"I reached out towards it."},
		{u"届くわけがない",
			u"But i couldn't possibly reach it."},
		{u"僕は悲しくなってきた",
			u"I started to feel sad."},
		{u"悲しくて悲しくて",
			u"Hopelessly, disconsolately sad."},
		{u"涙がこぼれるのを止められない",
			u"I couldn't stop my tears."},
		{u"あの人が誰だったのか",
			u"Who was that person?"},
		{u"僕は思い出そうとしている",
			u"I tried to remember."},
		{u"だけど、思い出せそうで思い出せない",
			u"But I couldn't put my finger on it."},
		{u"そうだ",
			u"That's right."},
		{u"僕も早く帰らないと",
			u"I have to go back soon, too."},
		{u"でもどこに？",
			u"But to where?"},
		{u"どうやって？",
			u"And how?"},
		{u"思い出せない",
			u"I couldn't remember."},
		{u"帰る場所が分からない",
			u"I didn't know where I could return to."},
		{u"帰る道も分からない",
			u"I didn't know the path to take."},
		{u"僕には、もう帰る家がなかった",
			u"I didn't have a home to go back to anymore."}
	};
}

namespace MUSIC {

	const uint32_t titleOffsets[] = {
		0x215DF258,
		0x215DF270,
		0x215DF288,
		0x215DF2A0,
		0x215DF2B8,
		0x215DF2D0,
		0x215DF2E8,
		0x215DF300,
		0x215DF318,
		0x215DF330,
		0x215DF348,
		0x215DF360,
		0x215DF378,
		0x215DF390,
		0x215DF3A8,
		0x215DF3F0,
		0x215DF468,
		0x215DF3C0,
		0x215DF3D8,
		0x215DF510,
		0x215DF528,
		0x215DF540,
		0x215DF558,
		0x215DF588,
		0x215DF5A0,
		0x215DF408,
		0x215DF5B8,
		0x215DF5D0,
		0x215DF5E8,
		0x215DF600,
		0x215DF618,
		0x215DF630,
		0x215DF648,
		0x215DF660,
		0x215DF678,
		0x215DF420,
		0x215DF438,
		0x215DF450,
		0x215DF480,
		0x215DF498,
		0x215DF4B0,
		0x215DF4C8,
		0x215DF4E0,
		0x215DF4F8,
		0x215DF570,
		0x215DF7B8,
		0x215DF7D0,
		0x215DF848,
		0x215DF860,
		0x215DF878,
		0x215DF890,
		0x215DF8A8,
		0x215DF8C0,
		0x215DF8D8,
		0x215DF8F0,
		0x215DF908,
		0x215DF920,
		0x215DF938,
		0x215DF950,
		0x215DF968,
		0x215DF800,
		0x215DF998,
		0x215DF9B0,
		0x215DF9C8,
		0x215DF9E0,
		0x215DF9F8,
		0x215DFA10,
		0x215DFA28,
		0x215DF7A0,
		0x215DFA40,
		0x215DF7E8,
		0x215DFA58,
		0x215DFA70,
		0x215DF6B0,
		0x215DFAA0,
		0x215DFAD0,
		0x215DFB00,
		0x215DFB30,
		0x215DF6E0,
		0x215DFB48,
		0x215DFB60,
		0x215DFB78,
		0x215DF6C8,
		0x215DFB90,
		0x215DF710,
		0x215DFBA8,
		0x215DF6F8,
		0x215DF830,
		0x215DFBC0,
		0x215DF740,
		0x215DF770,
		0x215DFA88,
		0x215DFAB8,
		0x215DFAE8,
		0x215DF980,
		0x215DFB18,
		0x215DF788,
		0x215DFBD8,
		0x215DF818,
		0x215DFBF0,
		0x215DFC08,
		0x215DF728,
		0x215DF758,
		0x215DFC38,
		0x215DFC20
	};

	const char* Titles[] = {
		"Sea, You & Me",
		"Sea, You Next",
		"Sea, Your Memory",
		"White Loneliness",
		"White With You",
		"Other Side Blue",
		"Adventure For Black",
		"Golden Hours",
		"Wings Of Glass",
		"Amongst The Cicadas",
		"The Ideal Summer Vacation",
		"The Haze At The Top Of The Hill",
		"Summer's Lullaby",
		"The Leisure Of Sunlight",
		"A Summer Chill",
		"Resting Beneath The Trees",
		"The Waves Of Time",
		"I'll Do My Homework On August 32nd",
		"The Weaver Of Time",
		"This Memory, That Memory",
		"Tsumugi's Summer Vacation",
		"Twinkle Of Alcor",
		"Childish White",
		"Alka Tale ～memory～",
		"I Know That Idiot Is Behind Me",
		"The Sunlight Between My Fingers",
		"Summer Mischief",
		"Aventu～re D'Été",
		"Deep Blue Blue",
		"Alka Tale",
		"Lasting Moment",
		"Yasouka",
		"Hane no Yurikago",
		"Shiroha's Lullaby",
		"A Pocketful Of Summer$S028 ～Sea, You Again～",
		"Darkening Shadows",
		"In The Wake Of The Cicadas",
		"Short Night, Far Skies",
		"Enveloped In Brilliance",
		"Alka Tale ～recall～",
		"Beyond The Sunlight",
		"Our Adventure",
		"The Adventures Of The Scurvy Cats",
		"Lost At Night",
		"Summer Pockets",
		"The Haze At The Top Of The Hill",
		"Summer's Lullaby",
		"Resting Beneath The Trees",
		"The Sunlight Between My Fingers",
		"Darkening Shadows",
		"In The Wake Of The Cicadas",
		"Short Night, Far Skies",
		"The Waves Of Time",
		"Enveloped In Brilliance",
		"Alka Tale ～recall～",
		"Beyond The Sunlight",
		"Our Adventure",
		"The Adventures Of The Scurvy Cats",
		"Lost At Night",
		"This Memory, That Memory",
		"A Summer Chill",
		"Tsumugi's Summer Vacation",
		"Twinkle of Alcor",
		"Childish White",
		"Summer Pockets",
		"Alka Tale ~memory~",
		"I Know That Idiot Is Behind Me",
		"Summer Mischief",
		"The Ideal Summer Vacation",
		"Aventu～re D'Été",
		"The Leisure Of Sunlight",
		"Deep Blue Blue",
		"Splash Green",
		"Sea, You & Me",
		"Piece of Clear",
		"Aster Of Summer",
		"Asterlore ～blue～",
		"Twinkle of Aster",
		"Sea, Your Memory",
		"Lingering Heat On The Wind",
		"Lover Universe",
		"Alka Tale",
		"Sea, You Next",
		"Lasting Moment",
		"White with You",
		"Yasouka",
		"White Loneliness",
		"The Weaver Of Time",
		"Hane no Yurikago",
		"Adventure for Black",
		"Wings Of Glass",
		"Tender Purple",
		"Run Red Run",
		"Scent Of The Sea",
		"Butterfly Of Iridescence",
		"Asterlore ～reflect～",
		"Amongst The Cicadas",
		"Shiroha's Lullaby",
		"I'll Do My Homework On August 32nd",
		"Asterlore",
		"Summer Hourglass",
		"Other side Blue",
		"Golden Hours",
		"A Pocketful Of Summer$S028 ～Sea, You Again～",
		"From The Blue"
	};
}
