#include <string>
#include <stdexcept>

struct hashTable {
	uint64_t hash;
	const char filepath[52];
};

template <typename T> constexpr bool has_duplicates(const T *array, std::size_t size)
{
    for (std::size_t i = 1; i < size; i++)
        for (std::size_t j = 0; j < i; j++)
            if (array[i].hash == array[j].hash) {
                return true;
			}
    return false;
}

constexpr hashTable TEXTURE_HASHES[] = {
	{0x38A29341FF2E16E6lu, "PARTS/CONFIG_BG"},
	{0x5523E0BD4A9CA2CDlu, "PARTS/CONFIG_TAB"},
	{0xD2355C93F71C768Elu, "PARTS/EXTRA_HEADER"},
	{0xB8F1D8A50D07DDADlu, "PARTS/SYSTEMMENU"},
	{0x3B33FD772270EFFBlu, "SYSCGRB/MCM_INFO"},
	{0xE03E92E730C85E73lu, "SYSCGRB/MCM_INFO_2"},
	{0x23FEE248569E58C5lu, "SYSCG/MCM_LIST"},
	{0x50B76A6FE3A5397Elu, "SYSCGRB/MCM_LIST_2"},
	{0x6F5874A0270C0AD6llu, "SYSCGRB/CGM_CLOSE00"},
	{0x88CC8F1145C985B0llu, "SYSCGRB/CGM_CLOSE01"},
	{0xA21B6FC473337A8llu, "SYSCGRB/CGM_CLOSE02"},
	{0xFFF40137299D45DFllu, "SYSCGRB/CGM_CLOSE03"},
	{0x8B3E3C3522FBE2C6llu, "SYSCGRB/CGM_CLOSE04"},
	{0x7B3EDF4D5ABA0D35llu, "SYSCGRB/CGM_CLOSE05"},
	{0xA9A5390CBF6457D1llu, "SYSCGRB/CGM_CLOSE06"},
	{0x65BD2247787059A0llu, "SYSCGRB/CGM_CLOSE07"},
	{0x34449B7F142B079llu, "SYSCGRB/CGM_CLOSE08"},
	{0x158176ED6081427Ellu, "SYSCGRB/CGM_NAME00"},
	{0x9A79B3EB145C7825llu, "SYSCGRB/CGM_NAME01"},
	{0x3169170611C03E0Allu, "SYSCGRB/CGM_NAME02"},
	{0x4C6A8E32487D6B67llu, "SYSCGRB/CGM_NAME03"},
	{0xB47E73DC7EC9F2A4llu, "SYSCGRB/CGM_NAME04"},
	{0x71578648E050508Allu, "SYSCGRB/CGM_NAME05"},
	{0xE70862F62201ABCllu, "SYSCGRB/CGM_NAME06"},
	{0x8CF3EDDBE6F746A9llu, "SYSCGRB/CGM_NAME07"},
	{0xFCF1CCC0B179BB20llu, "SYSCGRB/CGM_NAME08"},
	{0xC29ED90B36F8F843llu, "SYSCGRB/CGM_NAME09"},
	{0x1597BBB3DFCA3006llu, "SYSCGRB/CGM_NAME10"},
	{0xEDA85432EFD27ABClu, "SYSCGRB/CGM_SELECT"},
	{0xB5BB1187EC4BFB9Cllu, "SYSCGRB/TITLE_MENU01"},
	{0xAD694B2391D23C98llu, "SYSCGRB/TITLE_MENU01B"},
	{0x6D7D6ED24335FFBBllu, "SYSCGRB/TITLE_MENU01B_GLOW"},
	{0xD33BCF46EADDCBFllu, "SYSCGRB/TITLE_MENU01B_GLOW_2"},
	{0x5DCB67D6A980A5BAllu, "OTHCGRB/__SYS_MAP_SPOT00RB"},
	{0x8B4FC218FD161D59llu, "OTHCGRB/__SYS_RBLOGO02A"},
	{0xC16FEB04813267EBllu, "OTHCGRB/__SYS_RBLOGO02B"},
	{0xB3AE12E58475D89Fllu, "OTHCGRB/RB_TABLE_TENNIS_FREE_MATCH_CHARACTER_BTN"},
	{0xBDBB67DDA8BA7DFAllu, "OTHCGRB/RB_TABLE_TENNIS_FREE_MATCH_CHARACTER_CURSOL"},
	{0x3BC070CD87495C42llu, "OTHCGRB/RB_TABLE_TENNIS_FREE_MATCH_DIFFICULTY_BTN"},
	{0x7D0E08CAB672ABBEllu, "OTHCGRB/RB_TABLE_TENNIS_MAP_HELP_BTN"},
	{0x450C71F7BC2B71C3llu, "OTHCGRB/RB_TABLE_TENNIS_MAP_HELP_01"},
	{0x4E9B1C52C83D977Cllu, "OTHCGRB/RB_TABLE_TENNIS_MAP_HELP_02"},
	{0x592F45305905FDA7llu, "OTHCGRB/RB_TABLE_TENNIS_MAP_HELP_03"},
	{0x6FC95931731235A2llu, "OTHCGRB/RB_TABLE_TENNIS_MAP_HELP_04"},
	{0xEBF8311EE4871254llu, "OTHCGRB/RB_TABLE_TENNIS_MAP_HELP_05"},
	{0x8E6DD8BEC6223574llu, "OTHCGRB/RB_TABLE_TENNIS_MAP_HELP_06"},
	{0x16BD927FE9F417A6llu, "OTHCGRB/RB_TABLE_TENNIS_MAP_HELP_07"},
	{0x43C01FD16807235Ellu, "OTHCGRB/RB_TABLE_TENNIS_MAP_PLACE_IMAGE"},
	{0x950AAF39495DECF1llu, "OTHCGRB/RB_TABLE_TENNIS_MAP_RETURN_BTN"},
	{0x3679E9C13A41B1Bllu, "OTHCGRB/RB_TABLE_TENNIS_PAUSE_DIALOG_BG"},
	{0x2EFE3C06F3DBBA7Dllu, "OTHCGRB/RB_TABLE_TENNIS_PAUSE_DIALOG_BG1"},
	{0xC19DE8010B5ACEC8llu, "OTHCGRB/RB_TABLE_TENNIS_PAUSE_DIALOG_BTN"},
	{0xC39B0421832EE1D2llu, "OTHCGRB/RB_TABLE_TENNIS_PAUSE_DIALOG_TWEET_BTN"},
	{0xE12A32220C494BB6llu, "OTHCGRB/RB_TABLE_TENNIS_PAUSE"},
	{0xCBADB13296A477CBllu, "OTHCGRB/RB_TABLE_TENNIS_PLAYER_THUMB_NAME07"},
	{0x76E80BA82A595E03llu, "OTHCGRB/RB_TABLE_TENNIS_PLAYER_THUMB_NAME11B"},
	{0xD2ADB9090E8D5A64llu, "OTHCGRB/RB_TABLE_TENNIS_PLAYER_THUMB_NAME12"},
	{0xD2C7E0287479C5E0llu, "OTHCGRB/RB_TABLE_TENNIS_SPSHOT_FONT"},
	{0xB211F1E21B37F273llu, "OTHCGRB/RB_TABLE_TENNIS_ZONE_BATTLE_FONT"},
	{0xB437F3E71A11FAE8llu, "OTHCGRB/RB_TABLE_TENNIS_ZONE_DETAIL"},
	{0x82A296868D263160llu, "OTHCG/__SYS_KM_BG00"},
	{0x85FAAA7E114B6B98llu, "OTHCG/__SYS_KM_SETBTN_BG00"},
	{0x7CEC2FC1C1CB7DFDllu, "OTHCG/__SYS_TM_SETBTN_BG00A"},
	{0xEAEAC3C592441B73llu, "OTHCG/__SYS_TM_SETBTN_BG00B"},
	{0x545B44D598CF99D8llu, "OTHCG/__SYS_TM_SETBTN_BG00E"},
	{0x4D48305A63424A5Cllu, "OTHCG/__SYS_TM_SETBTN07"},
	{0x6132FDDD80F4236Fllu, "OTHCG/EF_CHARACTER01_00"},
	{0xDAB87E80CFF77159llu, "OTHCG/EF_CHARACTER01_01"},
	{0xCA3E26D3EBB3F397llu, "OTHCG/EF_CHARACTER01_02"},
	{0xB52140F35DCEAB66llu, "OTHCG/EF_CHARACTER01_03"},
	{0xC50133DCBB9FB270llu, "OTHCG/EF_CHARACTER01_04"},
	{0xB3443C8221A71B5Cllu, "OTHCG/EF_CHARACTER01_05"},
	{0x860905A1CD2EF0CAllu, "OTHCG/EF_CHARACTER01_06"},
	{0x6E2D22999F1DD906llu, "OTHCG/EF_CHARACTER01_07"},
	{0x923B1B67189FB9D0llu, "OTHCG/EF_CHARACTER01_08"},
	{0xA4A5AE3720870C1Bllu, "OTHCG/EF_CHARACTER01_09"},
	{0x9CDEBE580B5E1FBCllu, "OTHCG/EF_CHARACTER01_10"},
	{0xBEFC1FD5BF366D6llu, "OTHCG/EF_CHARACTER01_11"},
	{0xB8E148D832ADB63llu, "OTHCG/EF_CHARACTER01_12"},
	{0xBE9DA1A5DBF01D18llu, "OTHCG/EF_CHARACTER01_13"},
	{0x1B3086976FBE2086llu, "OTHCG/EF_CHARACTER01_14"},
	{0x93C173A0D7E62562llu, "OTHCG/EF_CHARACTER01_15"},
	{0x96DA6B5EF113E89Fllu, "OTHCG/EF_CHARACTER01_16"},
	{0x8C3E749B71CD8C4Fllu, "OTHCG/EF_CHARACTER02_00"},
	{0xA12076B041FA4889llu, "OTHCG/EF_CHARACTER02_01"},
	{0x44ED4590A0827D83llu, "OTHCG/EF_CHARACTER02_02"},
	{0x4BFF9115390659D5llu, "OTHCG/EF_CHARACTER02_03"},
	{0x262B41F9F5C23AD7llu, "OTHCG/EF_CHARACTER02_04"},
	{0x862EEA6DF4747E7Allu, "OTHCG/EF_CHARACTER02_05"},
	{0x675C88B2B8595B21llu, "OTHCG/EF_CHARACTER02_06"},
	{0x6FF8FC4604FE484llu, "OTHCG/EF_CHARACTER02_07"},
	{0xA0979122571E8EADllu, "OTHCG/EF_CHARACTER02_08"},
	{0x965238041D349DB0llu, "OTHCG/EF_CHARACTER02_09"},
	{0x80471BE3FDCD573Dllu, "OTHCG/EF_CHARACTER02_10"},
	{0x11E2F01CB3E463F5llu, "OTHCG/EF_CHARACTER02_11"},
	{0x450A3B27A8756536llu, "OTHCG/EF_CHARACTER02_12"},
	{0x89FB16BE2792E961llu, "OTHCG/EF_CHARACTER02_13"},
	{0xCEDD09C9790F29CAllu, "OTHCG/EF_CHARACTER02_14"},
	{0x5398EF792422EBF9llu, "OTHCG/EF_CHARACTER03_00"},
	{0xEA73951708102DEFllu, "OTHCG/EF_CHARACTER03_01"},
	{0x653D4642F9D3C686llu, "OTHCG/EF_CHARACTER03_02"},
	{0xD8E2710D99B71E1Cllu, "OTHCG/EF_CHARACTER03_03"},
	{0x5FBA056BD082B3D2llu, "OTHCG/EF_CHARACTER03_04"},
	{0x988BF0BA84F4CC6Cllu, "OTHCG/EF_CHARACTER03_05"},
	{0x8C038E95078C5815llu, "OTHCG/EF_CHARACTER03_06"},
	{0x2A3B372AA1E55012llu, "OTHCG/EF_CHARACTER03_07"},
	{0x19DCE97829B147F1llu, "OTHCG/EF_CHARACTER03_08"},
	{0x4330C56E4B3BEA1Cllu, "OTHCG/EF_CHARACTER03_09"},
	{0x11238496838163F7llu, "OTHCG/EF_CHARACTER03_10"},
	{0xE23D6B09E6049C6Cllu, "OTHCG/EF_CHARACTER03_11"},
	{0xC898E8E41A5BDDC0llu, "OTHCG/EF_CHARACTER03_12"},
	{0x54D84D394ADF83D9llu, "OTHCG/EF_CHARACTER04_00"},
	{0x6062866DC1E46A1Cllu, "OTHCG/EF_CHARACTER04_01"},
	{0x89D304B4E14DDE65llu, "OTHCG/EF_CHARACTER04_02"},
	{0xF3D2AAF265F00473llu, "OTHCG/EF_CHARACTER04_03"},
	{0x255CD5333EC9A7E6llu, "OTHCG/EF_CHARACTER04_04"},
	{0x67732318CB2E70F1llu, "OTHCG/EF_CHARACTER04_05"},
	{0xDD3BC95E7298BE1Allu, "OTHCG/EF_CHARACTER04_06"},
	{0xE7A49F8FA388678Allu, "OTHCG/EF_CHARACTER04_07"},
	{0xA100D6F9F4CCDE7Allu, "OTHCG/EF_CHARACTER04_08"},
	{0xFFE8B1AC1857D9BEllu, "OTHCG/EF_CHARACTER04_09"},
	{0xD19EC5AD0AFF4578llu, "OTHCG/EF_CHARACTER04_10"},
	{0x975CF5580F6CB05Bllu, "OTHCG/EF_CHARACTER04_11"},
	{0x945DBEC237B66288llu, "OTHCG/EF_CHARACTER04_12"},
	{0x23B3C20F4B8C16C4llu, "OTHCG/EF_CHARACTER04_13"},
	{0xB7C1E6C87C844C93llu, "OTHCG/EF_CHARACTER04_14"},
	{0xBC786CAEFD077A69llu, "OTHCG/EF_CHARACTER05_00"},
	{0x5F1D30D3C3763D84llu, "OTHCG/EF_CHARACTER05_01"},
	{0x4678161FED4CFB57llu, "OTHCG/EF_CHARACTER05_02"},
	{0x6962E622D70B35E7llu, "OTHCG/EF_CHARACTER05_03"},
	{0xECB7E22F620B1B27llu, "OTHCG/EF_CHARACTER05_04"},
	{0x797028FF9AE381ECllu, "OTHCG/EF_CHARACTER05_05"},
	{0x460C7859402429F0llu, "OTHCG/EF_CHARACTER05_06"},
	{0x44D2774F74CF415Allu, "OTHCG/EF_CHARACTER05_07"},
	{0x4BC84E4882C4B94Ellu, "OTHCG/EF_CHARACTER05_08"},
	{0x6DCF39D837BBECAEllu, "OTHCG/EF_CHARACTER05_09"},
	{0x78F90236B472C478llu, "OTHCG/EF_CHARACTER05_10"},
	{0x4085D8FD38585633llu, "OTHCG/EF_CHARACTER05_11"},
	{0x4F44617416C6B455llu, "OTHCG/EF_CHARACTER05_12"},
	{0x6680A7FFEDF50B9llu, "OTHCG/EF_CHARACTER05_13"},
	{0xDCD43FB1C5C8DA50llu, "OTHCG/EF_CHARACTER05_15"},
	{0xC5CCA888F3CFE16Allu, "OTHCG/EF_CHARACTER05_16"},
	{0xFE6EA8C67E9BF36Dllu, "OTHCG/EF_CHARACTER06_00"},
	{0x268991847BE051Bllu, "OTHCG/EF_CHARACTER06_01"},
	{0x1CBFFBDBDA71A042llu, "OTHCG/EF_CHARACTER06_02"},
	{0xFA64EE3003130A17llu, "OTHCG/EF_CHARACTER06_03"},
	{0xA30FCCA977DF29F2llu, "OTHCG/EF_CHARACTER06_04"},
	{0x972B52351A7AA40Fllu, "OTHCG/EF_CHARACTER06_05"},
	{0xD50DE11A1E29A76Dllu, "OTHCG/EF_CHARACTER06_06"},
	{0x20F65AD8DC0192AFllu, "OTHCG/EF_CHARACTER06_07"},
	{0x4219B3FB9264697Bllu, "OTHCG/EF_CHARACTER06_08"},
	{0x17F172FD70F5067Cllu, "OTHCG/EF_CHARACTER06_09"},
	{0x692178DA386AA51Ellu, "OTHCG/EF_CHARACTER06_10"},
	{0xB54E8957936E07EAllu, "OTHCG/EF_CHARACTER06_11"},
	{0xD3A776776C31EA44llu, "OTHCG/EF_CHARACTER06_12"},
	{0xCCA9999510569593llu, "OTHCG/EF_CHARACTER06_13"},
	{0x7EBFF652BD6995Ellu, "OTHCG/EF_CHARACTER06_14"},
	{0xD9A4D4D469CC35B5llu, "OTHCG/EF_CHARACTER06_15"},
	{0x60C29BE6FD0337ECllu, "OTHCG/EF_CHARACTER06_16"},
	{0x84B28E63219E188Fllu, "OTHCG/EF_CHARACTER06_17"},
	{0x9A5FEC3A86C65955llu, "OTHCG/EF_CHARACTER06_18"},
	{0xFAF4982C79E5E319llu, "OTHCG/EF_CHARACTER06_19"},
	{0x987F4914D61931F8llu, "OTHCG/EF_CHARACTER07_00"},
	{0xE8ADDA69D81CCAE8llu, "OTHCG/EF_CHARACTER07_01"},
	{0xF561AAEC81AD5970llu, "OTHCG/EF_CHARACTER07_02"},
	{0x52856341DDA66AA9llu, "OTHCG/EF_CHARACTER07_03"},
	{0x1310E5228ECC5CDEllu, "OTHCG/EF_CHARACTER07_04"},
	{0xEE0DFEF01121D67Fllu, "OTHCG/EF_CHARACTER07_05"},
	{0x6CD3C7772ADFE32Allu, "OTHCG/EF_CHARACTER07_06"},
	{0x1A6801675E360F1Dllu, "OTHCG/EF_CHARACTER07_07"},
	{0xE44C6DD1B9F68299llu, "OTHCG/EF_CHARACTER07_08"},
	{0x8C2C6F0770F1B4F5llu, "OTHCG/EF_CHARACTER07_09"},
	{0xCFC756A363753547llu, "OTHCG/EF_CHARACTER07_10"},
	{0xBCF292D26E21891Bllu, "OTHCG/EF_CHARACTER07_11"},
	{0x6B6B40E5F11D4962llu, "OTHCG/EF_CHARACTER07_12"},
	{0xF08759FB0CB97C57llu, "OTHCG/EF_CHARACTER07_14"},
	{0xD40664F0D7598E7Allu, "OTHCG/EF_CHARACTER07_15"},
	{0x230E0A358031E89Dllu, "OTHCG/EF_CHARACTER07_16"},
	{0x35B0FABECB5231BFllu, "OTHCG/EF_CHARACTER07_17"},
	{0xC8DBB1CE9D6D3F06llu, "OTHCG/EF_CHARACTER07_18"},
	{0x6416D4949499814llu, "OTHCG/EF_CHARACTER07_19"},
	{0x1408E5D8031AC1F1llu, "OTHCG/EF_CHARACTER07_20"},
	{0x91BDAEA08FA293B6llu, "OTHCG/EF_CHARACTER08_01"},
	{0xA066647EF0AA0A8Dllu, "OTHCG/EF_CHARACTER08_02"},
	{0x3F9DA7AF9E38BF5Cllu, "OTHCG/EF_CHARACTER08_03"},
	{0x5B64ED50E92D5904llu, "OTHCG/EF_CHARACTER08_04"},
	{0x302954303EE86BAllu, "OTHCG/EF_CHARACTER08_05"},
	{0x72E7D862AB6F485Allu, "OTHCG/EF_CHARACTER08_06"},
	{0xD4FF034C13F9A933llu, "OTHCG/EF_CHARACTER08_07"},
	{0x4CD2D6DDCCC8BE9Cllu, "OTHCG/EF_CHARACTER08_08"},
	{0xB8890BF2F161AEBBllu, "OTHCG/EF_FONT_AO01"},
	{0x45D7EB04B2443F24llu, "OTHCG/EF_FONT_AO02"},
	{0x506D8639CBC566C9llu, "OTHCG/EF_FONT_AO03"},
	{0x7232461A066765DBllu, "OTHCG/EF_FONT_AO04"},
	{0xE833950D335E3E1llu, "OTHCG/SFIGHT_BATTLE_HEADER_FILED"},
	{0x99590039FFB7F71Fllu, "OTHCG/SFIGHT_BATTLE_HEADER_TURN"},
	{0x64A9DECD70EF7A30llu, "OTHCG/SFIGHT_BATTLE_SELECT_FONT"},
	{0x1E4DD589DCDDD21Allu, "OTHCG/SFIGHT_CARD_0001_FULL"},
	{0xB2C8358ECB7EAF14llu, "OTHCG/SFIGHT_CARD_0002_FULL"},
	{0xC7F83A6470A6127Dllu, "OTHCG/SFIGHT_CARD_0003_FULL"},
	{0x34B3A52FE7761069llu, "OTHCG/SFIGHT_CARD_0004_FULL"},
	{0x6754152A8D4001C7llu, "OTHCG/SFIGHT_CARD_0005_FULL"},
	{0x365D7A5E82B9CABBllu, "OTHCG/SFIGHT_CARD_0006_FULL"},
	{0xA465C38FD2D3EB7Fllu, "OTHCG/SFIGHT_CARD_0007_FULL"},
	{0x70DD7D54ABC5DE82llu, "OTHCG/SFIGHT_CARD_0008_FULL"},
	{0x1F1911C6669934A2llu, "OTHCG/SFIGHT_CARD_0009_FULL"},
	{0x78B52AA21BF91DB2llu, "OTHCG/SFIGHT_CARD_0010_FULL"},
	{0x7E413942C9116FC2llu, "OTHCG/SFIGHT_CARD_0011_FULL"},
	{0x24D97564081185Dllu, "OTHCG/SFIGHT_CARD_0012_FULL"},
	{0xCB8CF9A604CB89A8llu, "OTHCG/SFIGHT_CARD_0013_FULL"},
	{0x472EBCF1D9807A07llu, "OTHCG/SFIGHT_CARD_0014_FULL"},
	{0x2B0C129670708CDFllu, "OTHCG/SFIGHT_CARD_0015_FULL"},
	{0xD8D8E1D178C0C7ADllu, "OTHCG/SFIGHT_CARD_0016_FULL"},
	{0x1A1A9CC4E9EC3740llu, "OTHCG/SFIGHT_CARD_0017_FULL"},
	{0x9F2A76EA94029481llu, "OTHCG/SFIGHT_CARD_0018_FULL"},
	{0xCFBA8FE9D2245D92llu, "OTHCG/SFIGHT_CARD_0019_FULL"},
	{0xB6F72ADBB1ED3F6Fllu, "OTHCG/SFIGHT_CARD_0020_FULL"},
	{0x5B5FDA4666ADF88Fllu, "OTHCG/SFIGHT_CARD_0021_FULL"},
	{0x388C1771D5C0EB8Cllu, "OTHCG/SFIGHT_CARD_0022_FULL"},
	{0xEA409D803DC5D24Bllu, "OTHCG/SFIGHT_CARD_0023_FULL"},
	{0x27E997EC589E7E02llu, "OTHCG/SFIGHT_CARD_0024_FULL"},
	{0xEC85D74EDCC264ABllu, "OTHCG/SFIGHT_CARD_0025_FULL"},
	{0x796B27BE5A91FDC0llu, "OTHCG/SFIGHT_CARD_0026_FULL"},
	{0x3667689DCD7CEDC4llu, "OTHCG/SFIGHT_CARD_0027_FULL"},
	{0xA6BBD9D34084935Bllu, "OTHCG/SFIGHT_CARD_0028_FULL"},
	{0x2C981DB6114B9911llu, "OTHCG/SFIGHT_CARD_0029_FULL"},
	{0xDB3F9576BF7F5BF2llu, "OTHCG/SFIGHT_CARD_0030_FULL"},
	{0x3EA3DC7AE8995148llu, "OTHCG/SFIGHT_CARD_0031_FULL"},
	{0xA5F7E0155D76ED55llu, "OTHCG/SFIGHT_CARD_0032_FULL"},
	{0x9FED8358CAF19701llu, "OTHCG/SFIGHT_CARD_0033_FULL"},
	{0x79B91B15710E485Allu, "OTHCG/SFIGHT_CARD_0034_FULL"},
	{0x4A481F9BB7D7D1AFllu, "OTHCG/SFIGHT_CARD_0035_FULL"},
	{0xD0730A501DA9C4BBllu, "OTHCG/SFIGHT_CARD_0036_FULL"},
	{0x5257938519375EFFllu, "OTHCG/SFIGHT_CARD_0037_FULL"},
	{0x7EF5B3BBB5491F5Fllu, "OTHCG/SFIGHT_CARD_0038_FULL"},
	{0x22F2DA6AC9398725llu, "OTHCG/SFIGHT_CARD_0039_FULL"},
	{0x5C3A17ABA3CA4350llu, "OTHCG/SFIGHT_CARD_0040_FULL"},
	{0xDE82ED3002310707llu, "OTHCG/SFIGHT_CARD_0041_FULL"},
	{0x84B85FE496DC7276llu, "OTHCG/SFIGHT_CARD_0042_FULL"},
	{0xD6DEF76A4F1CED1Fllu, "OTHCG/SFIGHT_CARD_0043_FULL"},
	{0x5EFC61E1495FD946llu, "OTHCG/SFIGHT_CARD_0044_FULL"},
	{0xA0815E7B26C4E231llu, "OTHCG/SFIGHT_CARD_0045_FULL"},
	{0xB53461CF1566DDAEllu, "OTHCG/SFIGHT_CARD_0046_FULL"},
	{0x4D403B6DCB02B9D4llu, "OTHCG/SFIGHT_CARD_0047_FULL"},
	{0xE428F0EA0D8D6A1Ellu, "OTHCG/SFIGHT_CARD_0048_FULL"},
	{0x9F5D9D9674C17692llu, "OTHCG/SFIGHT_CARD_0049_FULL"},
	{0xDF9BA8EB0F019565llu, "OTHCG/SFIGHT_CARD_0050_FULL"},
	{0xFE611D184EB04D5Fllu, "OTHCG/SFIGHT_CARD_0051_FULL"},
	{0xCB96921BA76A4AB1llu, "OTHCG/SFIGHT_CARD_0052_FULL"},
	{0xEEC6288E564A745llu, "OTHCG/SFIGHT_CARD_0053_FULL"},
	{0x9CB77C1A0174DF7Allu, "OTHCG/SFIGHT_CARD_0054_FULL"},
	{0xCE1A637A4C7E1A7Cllu, "OTHCG/SFIGHT_CARD_0055_FULL"},
	{0x16ADB9585B4CAB36llu, "OTHCG/SFIGHT_CARD_0056_FULL"},
	{0xAB422E333E00FAEEllu, "OTHCG/SFIGHT_CARD_0057_FULL"},
	{0x59170E8A2E8D5020llu, "OTHCG/SFIGHT_CARD_0058_FULL"},
	{0x486079905853F076llu, "OTHCG/SFIGHT_CARD_0059_FULL"},
	{0x543BD7245BCC34A8llu, "OTHCG/SFIGHT_CARD_0060_FULL"},
	{0xE16F55FA8CDB5F04llu, "OTHCG/SFIGHT_CARD_0061_FULL"},
	{0x9FCD6FC643FAD1F8llu, "OTHCG/SFIGHT_CARD_0062_FULL"},
	{0x9FB7DE902FC31DC1llu, "OTHCG/SFIGHT_CARD_0063_FULL"},
	{0xDD809B7CFF7A555Cllu, "OTHCG/SFIGHT_CARD_0064_FULL"},
	{0x45E9D84AF20FCD4Dllu, "OTHCG/SFIGHT_CARD_0065_FULL"},
	{0xEB6D9F3664A948A2llu, "OTHCG/SFIGHT_CARD_0066_FULL"},
	{0x76A34903FCC7BA75llu, "OTHCG/SFIGHT_CARD_0067_FULL"},
	{0xBCAAB9B7112D0C1Fllu, "OTHCG/SFIGHT_CARD_0068_FULL"},
	{0x79E303A1F51DCB99llu, "OTHCG/SFIGHT_CARD_0069_FULL"},
	{0x9078B3C5DBE759AAllu, "OTHCG/SFIGHT_CARD_0070_FULL"},
	{0xBE3089C9695B5DD1llu, "OTHCG/SFIGHT_CARD_0071_FULL"},
	{0x3E97C36B83FADAFDllu, "OTHCG/SFIGHT_CARD_0072_FULL"},
	{0x472829B1D59E642llu, "OTHCG/SFIGHT_CARD_0073_FULL"},
	{0xC685A8373BDB21F2llu, "OTHCG/SFIGHT_CARD_0074_FULL"},
	{0xF84DBA98E6B1920Bllu, "OTHCG/SFIGHT_CARD_0075_FULL"},
	{0x55D3A7B203A71E15llu, "OTHCG/SFIGHT_CARD_0076_FULL"},
	{0x4F929C59326661ECllu, "OTHCG/SFIGHT_CARD_0077_FULL"},
	{0x45FB97C155D2153Allu, "OTHCG/SFIGHT_CARD_0078_FULL"},
	{0xFFF9D2EBE2372969llu, "OTHCG/SFIGHT_CARD_0079_FULL"},
	{0x43F934EF8F1612E1llu, "OTHCG/SFIGHT_CARD_0080_FULL"},
	{0x1EAB0C0DBF567157llu, "OTHCG/SFIGHT_CARD_0081_FULL"},
	{0x5D9AC6F4BCF83A78llu, "OTHCG/SFIGHT_CARD_0082_FULL"},
	{0xC4A2179448B85976llu, "OTHCG/SFIGHT_CARD_0083_FULL"},
	{0x585DFA3CE4383569llu, "OTHCG/SFIGHT_CARD_0084_FULL"},
	{0x588EF9D42BDFEBCDllu, "OTHCG/SFIGHT_CARD_0085_FULL"},
	{0x62BADD6DDCADA9E3llu, "OTHCG/SFIGHT_CARD_0086_FULL"},
	{0x89CC1BDD6F2877C4llu, "OTHCG/SFIGHT_CARD_0087_FULL"},
	{0x808569192200C94Ellu, "OTHCG/SFIGHT_CARD_0088_FULL"},
	{0xE331813FA9321BFDllu, "OTHCG/SFIGHT_CARD_0089_FULL"},
	{0x9A726AE9CC8C5ADllu, "OTHCG/SFIGHT_CARD_0090_FULL"},
	{0x7DBF05EFF9B58160llu, "OTHCG/SFIGHT_CARD_0091_FULL"},
	{0x75A3D2DF9BD5E9E7llu, "OTHCG/SFIGHT_CARD_0092_FULL"},
	{0xD93FA8EDA4161BA6llu, "OTHCG/SFIGHT_CARD_0093_FULL"},
	{0x2A6048E8CBB6B514llu, "OTHCG/SFIGHT_CARD_0094_FULL"},
	{0x6D1FD6946A8C427Allu, "OTHCG/SFIGHT_CARD_0095_FULL"},
	{0xE2DA0CD45261A23Allu, "OTHCG/SFIGHT_CARD_0096_FULL"},
	{0xD626111C1A4C34BAllu, "OTHCG/SFIGHT_CARD_0097_FULL"},
	{0xBF70EE4DCFF2976Bllu, "OTHCG/SFIGHT_CARD_0098_FULL"},
	{0xB517D4BBAB2170B5llu, "OTHCG/SFIGHT_CARD_0099_FULL"},
	{0xD309CBBC589D7BCCllu, "OTHCG/SFIGHT_CARD_0100_FULL"},
	{0xDA42B08BB35C5F75llu, "OTHCG/SFIGHT_CARD_0101_FULL"},
	{0xAE04B46E752255F0llu, "OTHCG/SFIGHT_CARD_0102_FULL"},
	{0x81A9BB53447BDF78llu, "OTHCG/SFIGHT_CARD_0103_FULL"},
	{0x3FAA7E8B6B6ADAD0llu, "OTHCG/SFIGHT_CARD_ICON_OVERLAY"},
	{0xF45C70453A447E5Dllu, "OTHCG/SFIGHT_CHARACTER_SELECT_INFO_BG"},
	{0x73E348230CDC9291llu, "OTHCG/SFIGHT_COMMON_BTN_BACK"},
	{0xA7F6D0DFC7859D53llu, "OTHCG/SFIGHT_COMMON_BTN_CANCEL"},
	{0x5F7AE38AF6E7C36Allu, "OTHCG/SFIGHT_COMMON_BTN_HELP"},
	{0xEF1A57DBBBDC9DBBllu, "OTHCG/SFIGHT_COMMON_BTN_OK"},
	{0xE6786A13178F161Allu, "OTHCG/SFIGHT_COMMON_FEED_INFO_BG"},
	{0x514EE30AE1BF60B6llu, "OTHCG/SFIGHT_COMMON_INFO_BG"},
	{0x565BBDDCFA30FD91llu, "OTHCG/SFIGHT_COMMON_TAG"},
	{0xCE529DC8B4407A04llu, "OTHCG/SFIGHT_DECK_BTN_BATTLE"},
	{0x168745ED7E60D088llu, "OTHCG/SFIGHT_DECK_BTN_EDIT"},
	{0x8D0C2E5F4206B1A2llu, "OTHCG/SFIGHT_DECK_BTN_SAVE"},
	{0xDFAC308D2E2EB906llu, "OTHCG/SFIGHT_DECK_BTN_SORT"},
	{0x1670E886DA6F491Ellu, "OTHCG/SFIGHT_DECK_FONT_SAVE"},
	{0x4D1EC073C31F90B7llu, "OTHCG/SFIGHT_FEED_SETTING_BTN_COMPLETE"},
	{0xC9D4EB60870878E8llu, "OTHCG/SFIGHT_FEED_SETTING_BTN_OK"},
	{0xFACE614157141E22llu, "OTHCG/SFIGHT_FEED_SETTING_PANEL_BG"},
	{0x205FE953BC1A4DDEllu, "OTHCG/SFIGHT_FEED_SETTING_SPOT_IMAGE"},
	{0x9BF768D870C266AFllu, "OTHCG/SFIGHT_FEED_SETTING_SPOT_NUMBER_BG"},
	{0xD395679B5C8C6680llu, "OTHCG/SFIGHT_FEED_SETTING_THUMB_BG"},
	{0x8BF68C480FA71166llu, "OTHCG/SFIGHT_HELP01"},
	{0x7B8EDF96B7E7C5ECllu, "OTHCG/SFIGHT_HELP02"},
	{0x972C68AB24F3BBFDllu, "OTHCG/SFIGHT_HELP03"},
	{0x58BA3C4C5E055C09llu, "OTHCG/SFIGHT_HELP05"},
	{0x2BD8C92895441051llu, "OTHCG/SFIGHT_HELP06"},
	{0x7509991F17B8A4Fllu, "OTHCG/SFIGHT_HELP07"},
	{0x200EC5DDAFBAAA39llu, "OTHCG/SFIGHT_LIBRARY_TAB_BTN"},
	{0xEA536C8A0D4F28CBllu, "OTHCG/SFIGHT_MAIN_BTN_BACK"},
	{0x8279F3C547E0C432llu, "OTHCG/SFIGHT_MAIN_BTN_DECK"},
	{0x95087CAC79B507F5llu, "OTHCG/SFIGHT_MAIN_BTN_LIBRARY"},
	{0x2DC037D44C361B6llu, "OTHCG/SFIGHT_MAIN_BTN_RANKING"},
	{0xB00F7F843A76A9A2llu, "OTHCG/SFIGHT_MAP_SPOT01"},
	{0xF0629E79BDF3EC17llu, "OTHCG/SFIGHT_MAP_SPOT02"},
	{0x6D3BACBBFDFF412Bllu, "OTHCG/SFIGHT_MAP_SPOT03"},
	{0x2A7290262EB77AFCllu, "OTHCG/SFIGHT_MAP_SPOT04"},
	{0x32C231ACFD109DF5llu, "OTHCG/SFIGHT_MAP_SPOT05"},
	{0xD3082AADA62B2BC2llu, "OTHCG/SFIGHT_MAP_SPOT06"},
	{0xA838ADD5A326F0Allu, "OTHCG/SFIGHT_MAP_SPOT07"},
	{0x37546186327C77llu, "OTHCG/SFIGHT_MAP_SPOT08"},
	{0xBF82240B0547F235llu, "OTHCG/SFIGHT_MAP_SPOT09"},
	{0x124D6AEF6049F378llu, "OTHCG/SFIGHT_MAP_SPOT10"},
	{0x322AA9DA671D678Fllu, "OTHCG/SFIGHT_RANKING_MYPAGE_BTN"},
	{0x69EFAC5169557E0Fllu, "OTHCG/SFIGHT_SORT_BG"},
	{0xFD0B1E46A35B5D0Dllu, "OTHCG/SFIGHT_SORT_BTN"},
	{0x8895AADFB779BC7Cllu, "OTHCG/SFIGHT_SORT_TEXT"},
	{0xF6AE09CA80036FE3llu, "OTHCG/Z_SFIGHT_COMMON_BTN_CLOSE"},
	{0xFF90ECBF0825D572llu, "OTHCG/TABLE_TENNIS_BG"},
	{0xD66DB2E52C9A9105llu, "OTHCG/TABLE_TENNIS_CONTINUE_BG"},
	{0x4DC26EE02C50E1A8llu, "OTHCG/TABLE_TENNIS_CONTINUE_BTN"},
	{0x154CAB51D5B5B332llu, "OTHCG/TABLE_TENNIS_ENTRY_BG"},
	{0xA473329FED80FA7Cllu, "OTHCG/TABLE_TENNIS_ENTRY_BTN"},
	{0xD7CB11B39E6588FAllu, "OTHCG/TABLE_TENNIS_HELP_BG"},
	{0x732A127CEC393B2llu, "OTHCG/TABLE_TENNIS_HELP_INFO"},
	{0x2C76D45053B8E9EDllu, "OTHCG/TABLE_TENNIS_LIFE_BG"},
	{0xDE52556D7165E19Cllu, "OTHCG/TABLE_TENNIS_PAUSE"},
	{0x72935F7181D06166llu, "OTHCG/TABLE_TENNIS_RESULT_BONUS_BG"},
	{0x98983D694CF1EB7lu, "OTHCG/TABLE_TENNIS_RESULT_BONUS_NUMBER"},
	{0xFD560C345D335013lu, "OTHCG/TABLE_TENNIS_RESULT_BONUS_RATE_NUMBER"},
	{0x7B7874E5DF234502lu, "OTHCG/TABLE_TENNIS_RESULT_BONUS_TIME"},
	{0x409DBF98161C0D4Allu, "OTHCG/TABLE_TENNIS_RESULT_NEXT"},
	{0x1F7A87D371F75AC5llu, "OTHCG/TABLE_TENNIS_RESULT_SCORE_BG"},
	{0xED355A8B25C91544lu, "OTHCG/TABLE_TENNIS_RESULT_SCORE_NUMBER"},
	{0xA7631A633B7EE2B4lu, "OTHCG/TABLE_TENNIS_SCORE_ADD_NUMBER"},
	{0x4DDD6396D4821DEFlu, "OTHCG/TABLE_TENNIS_SCORE_NUMBER"},
	{0xA80F978BDAB8F68llu, "OTHCG/TABLE_TENNIS_TIMER_BG"},
	{0x9910EB13D6DD0020llu, "OTHCG/TABLE_TENNIS_TUTORIAL_BG00"},
	{0x668D0EDD4CD23C00llu, "OTHCG/TABLE_TENNIS_TUTORIAL_BG10"},
	{0x76A739BDA66E59A7llu, "OTHCG/TABLE_TENNIS_TUTORIAL_BG20"},
	{0xAB4F67C52D30C22Allu, "OTHCG/TABLE_TENNIS_TUTORIAL_OV00"},
	{0x994C718AD02E88BEllu, "OTHCG/TABLE_TENNIS_TUTORIAL_OV01"},
	{0xB9D10DB64ED7D05Allu, "OTHCG/TABLE_TENNIS_TUTORIAL_OV10"},
	{0x3B4D3B7FC39A219Bllu, "OTHCG/TABLE_TENNIS_TUTORIAL_OV11"},
	{0x22AB4681DCA411A9llu, "OTHCG/TABLE_TENNIS_TUTORIAL_OV20"},
	{0xBB55F730C7302DF6llu, "OTHCG/TABLE_TENNIS_TUTORIAL_OV21"},
	{0xC41610705135EB5Dllu, "EVENTCG/0073"},
	{0xD2B812607F24EA3Bllu, "EVENTCG/0074"},
	{0xE0C2AE4D473ED5EDllu, "EVENTCG/0075"},
	{0xE3057E5E782A9120llu, "EVENTCG/0076"},
	{0x1285D2CFB1787269llu, "EVENTCG/0077"},
	{0x4526C7AE76062538llu, "EVENTCG/0078"},
	{0x452687A6E0913B23llu, "EVENTCG/0079"},
	{0xDE74C50BE2CD01D6llu, "EVENTCG/0080"},
	{0x3BC0C55507594458llu, "EVENTCG/0081"},
	{0xAB493398C8B5D684llu, "EVENTCG/0082"},
	{0xCA9578FE5916DE01llu, "EVENTCG/0083"},
	{0xA4138AB4E3D73B74llu, "EVENTCG/0084"},
	{0x364B2442FF93EFB2llu, "EVENTCG/0203"},
	{0x354BCD64E383D065llu, "EVENTCG/0204"},
	{0x8E8C0064B1839B5Dllu, "EVENTCG/0207"},
	{0xC1B785F579B8481Fllu, "EVENTCG/0213"},
	{0xB8499315410B7D76llu, "EVENTCG/0464"},
	{0x76A215EF6E6A0F64llu, "EVENTCG/0465"},
	{0x7F9D7BB8CB4CE077llu, "EVENTCG/0466"},
	{0xF5F01C29CA7862D2llu, "EVENTCG/0467"},
	{0xBA686B671D7EE87Dllu, "EVENTCG/0468"},
	{0xBE5504C57CC2ACFllu, "EVENTCG/0469"},
	{0xA8C91194BDA96499llu, "EVENTCG/0470"},
	{0xBE5A6B82F871C214llu, "EVENTCG/0471"},
	{0x5DB387473F65E228llu, "EVENTCG/0472"},
	{0x5FBFA1FAC1D274ACllu, "EVENTCG/0473"},
	{0x9C0001DD3EE10A4Cllu, "EVENTCG/0474"},
	{0xA9861BF92319BC14llu, "EVENTCG/0475"},
	{0xE15FDE705B27D7E5llu, "EVENTCG/0594"},
	{0x8DCE6E07ABC72180llu, "EVENTCG/0595"},
	{0x553E78E6D9FD6A48llu, "EVENTCG/0598"},
	{0x920B9B41351D0660llu, "EVENTCG/0604"}
};

static_assert(!has_duplicates(TEXTURE_HASHES, std::size(TEXTURE_HASHES)), "Detected repeated hash!");